#include <iostream>
#include <windows.h>
#include <process.h> // needed for function _beginthreadex()
void PrintError(LPTSTR lpszFunction,LPSTR fileName, int lineNumber) { 
	TCHAR szBuf[256]; LPSTR lpErrorBuf;
	DWORD errorCode = GetLastError(); 
	FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
	FORMAT_MESSAGE_FROM_SYSTEM, NULL, errorCode, 
	MAKELANGID(LANG_NEUTRAL, 
	SUBLANG_DEFAULT), (LPTSTR) &lpErrorBuf, 0, NULL );
	wsprintf(szBuf, "%s failed at line %d in %s with error %d: %s", lpszFunction, 
	lineNumber, fileName, errorCode, lpErrorBuf); 
 	DWORD numWritten;
	WriteFile(GetStdHandle(STD_ERROR_HANDLE),szBuf,strlen(szBuf),
	&numWritten,FALSE);
	LocalFree(lpErrorBuf);
	exit(errorCode); 
}
unsigned WINAPI simpleThread (LPVOID myID) {
// myID receives the 4th argument of _beginthreadex().
// Note: "WINAPI" refers to the "__stdcall" calling convention used to call Win32 // API functions, and "LPVOID" is a Win32 data type defined as void*
	std::cout << "Thread " << (unsigned) myID << " is running" << std::endl;
	return (unsigned) myID;
}
int main() {
	const int numThreads = 2;
	HANDLE threadArray[numThreads];	// array of thread handles
	unsigned threadID;	// returned by _beginthreadex(), but not used
	DWORD rc;	// return code; (DWORD is defined in WIN32 as unsigned long)
	// Create two threads and store their handles in array threadArray
	threadArray[0] = (HANDLE) _beginthreadex(NULL, 0, simpleThread, 
	(LPVOID) 1U, 0, &threadID);
	if (!threadArray[0]) 
	PrintError("_beginthreadex failed at ",__FILE__,__LINE__);
	threadArray[1] = (HANDLE) _beginthreadex(NULL, 0, simpleThread, 
	(LPVOID) 2U, 0, &threadID);
	if (!threadArray[1]) 
	PrintError("_beginthreadex failed at ",__FILE__,__LINE__);
	rc = WaitForMultipleObjects(numThreads,threadArray,TRUE,INFINITE); 	//wait for the threads to finish
	if (!(rc >= WAIT_OBJECT_0 && rc < WAIT_OBJECT_0+numThreads))
	PrintError("WaitForMultipleObjects failed at ",__FILE__,__LINE__);
	DWORD result1, result2;	// these variables will receive the return values
	rc = GetExitCodeThread(threadArray[0],&result1);
	if (!rc) PrintError("GetExitCodeThread failed at ",__FILE__,__LINE__);
	rc = GetExitCodeThread(threadArray[1],&result2);
	if (!rc) PrintError("GetExitCodeThread failed at ",__FILE__,__LINE__);
	std::cout << "thread1:" << result1 << " thread2:" << result2 << std::endl;
	rc = CloseHandle(threadArray[0]);	// release reference to thread when finished
	if (!rc) PrintError("CloseHandle failed at ",__FILE__,__LINE__);
	rc = CloseHandle(threadArray[1]);
	if (!rc) PrintError("CloseHandle failed at ",__FILE__,__LINE__);
	return 0;
}

//Listing 1.3 A simple concurrent program using C++/Win32.

