#include "thread.h"
#include "runnable.h"
#include "sharedVariable.h"
#include <iostream>
#include <memory>

sharedVariable<int> s(0); // shared variable s

class communicatingThread: public TDThread {
public:
	communicatingThread(int ID) : myID(ID) {}
	virtual void* run();
private:
	int myID;
};
void* communicatingThread::run() {
	std::cout << "Thread " << myID << " is running" << std::endl;
	for (int i=0; i<2; i++)		// increment s two times (not 10 million times)
	s = s + 1;
	return 0;
}
int main() {
	std::auto_ptr<communicatingThread> thread1(new communicatingThread (1));
	std::auto_ptr<communicatingThread> thread2(new communicatingThread (2));
	thread1->start();	thread2->start();
	thread1->join();	thread2->join();
	std::cout << "s: " << s << std::endl;		// the expected final value of s is 4
	return 0;
}

//Listing 1.9 Using classes TDThread and sharedVariable<>.

