
//: Listing 1-5.cpp: Using C++/Win32 Classes Thread and Runnable
#include "thread.h"
#include "runnable.h"
#include <iostream>

class simpleRunnable: public Runnable {
public:
	simpleRunnable(int ID) : myID(ID) {}
	virtual void* run();
private:
	int myID;
};
void* simpleRunnable::run() {
	std::cout << "Thread " << myID << " is running" << std::endl;
	return reinterpret_cast<void*>(myID);
}

class simpleThread: public Thread {
public:
	simpleThread (int ID) : myID(ID) {}
	virtual void* run();
private:
	int myID;
};
void* simpleThread::run() {
	std::cout << "Thread " << myID << " is running" << std::endl;
	return reinterpret_cast<void*>(myID);
}

int main() {
	std::auto_ptr<Runnable> r(new simpleRunnable(1));
	std::auto_ptr<Thread> thread1(new Thread(r));
	thread1->start();
	std::auto_ptr<simpleThread> thread2(new simpleThread(2));
	thread2->start();
	simpleThread thread3(3);
	thread3.start();
	// thread1 and thread2 are created on the heap; thread3 is created on the stack
	long result1 = reinterpret_cast<long>(thread1->join());
	long result2 = reinterpret_cast<long>(thread2->join());
	long result3 = reinterpret_cast<long>(thread3.join()); 			// wait for the three threads to complete
	std::cout << result1 << ' ' << result2 << ' ' << result3 << std::endl;
	return 0;
}

