
//: Listing 1-8.cpp
#include "thread.h"
#include "runnable.h"
#include <iostream>

int s=0; // shared variable s
	
class communicatingThread: public Thread {
public:
	communicatingThread (int ID) : myID(ID) {}
	virtual void* run();
private:
	int myID;
};
void* communicatingThread::run() {
	std::cout << "Thread " << myID << " is running" << std::endl;
	for (int i=0; i<10000000; i++) // increment s ten million times
	s = s + 1;
	return 0;
}

int main() {
	std::auto_ptr<communicatingThread> thread1(new communicatingThread (1));
	std::auto_ptr<communicatingThread> thread2(new communicatingThread (2));
	thread1->start();	thread2->start();
	thread1->join();	thread2->join();
	std::cout << "s: " << s << std::endl; // expected final value of s is 20000000
	return 0;
}
