#ifndef THREAD_H
#define THREAD_H
#pragma warning(disable:4786) 
#include "runnable.h"
#include <windows.h>
#include <memory>
#include <iostream>
				
class Thread {
public:
	//Thread(Runnable*  runnable_);
	Thread(std::auto_ptr<Runnable> runnable_);
	Thread();
    virtual ~Thread();
    void start();	// threads are created in suspended state; this starts them
	void* join();
	//void* GetExitCodeThread(); // get return value of run() method
    //static const DWORD ACTIVE = 259; // indicates thread is still active when GetExitCodeThread() is called
private:
    HANDLE hThread;
    unsigned winThreadID; // Win32 thread ID
    //Runnable* runnable;
	std::auto_ptr<Runnable> runnable;
	Thread(const Thread&);
    const Thread& operator= (const Thread&);
	HANDLE completionEvent;
	void setCompleted();
	void* result;			// stores return value of run()
	//bool completed;			// true if run() method has completed
	static unsigned WINAPI startThreadRunnable(LPVOID pVoid);
	virtual void* run() {return 0;}
	static unsigned WINAPI startThread(LPVOID pVoid);
	void PrintError(LPTSTR lpszFunction,LPSTR fileName, int lineNumber);
};
#endif
