#ifndef BINARYSEMAPHORE_H
#define BINARYSEMAPHORE_H

#pragma warning(disable:4786) 
#include "semaphore.h"
#include "win32Semaphore.h"
#include "semaphorePool.h"
#include <windows.h>
#include "criticalSectionLock.h"
#include "semaphoreAndLockTracingAndReplay.h"
#include <queue>



class binarySemaphore : public semaphore {
// a FIFO binary semaphore

private:
	std::queue<waitRecord> waitingP; // queue of threads blocked on P
	std::queue<waitRecord> waitingV; // queue of threads blocked on V
    bool doP();
	semaphorePool pool; // resource pool of semaphores

	int numControllers;
	int mode;
	bool randomDelay;
	bool detectDeadlock;
	std::string generateID();
	std::string semaphoreName;
	virtual bool isBinarySemaphore() {return true;}
	
	semaphoreAndLockTracingAndReplay* control;

public:
	binarySemaphore(int initialPermits, bool traceAndReplay=true);
	~binarySemaphore();
    void P();

    void V();

    void VP(semaphore* vSem);

};
#endif
