#ifndef COUNTINGSEMAPHORE_H
#define COUNTINGSEMAPHORE_H

#pragma warning(disable:4786) 
#include "semaphore.h"
#include "win32Semaphore.h"
#include "semaphorePool.h"
#include "criticalSectionLock.h"
#include "semaphoreAndLockTracingAndReplay.h"
#include <queue>


class countingSemaphore : public semaphore {
// a FIFO binary semaphore
private:
	std::queue<waitRecord> waitingP; // queue of threads blocked on P
    	bool doP();
	semaphorePool pool;
	int numControllers;
	int mode;
	bool randomDelay;
	bool detectDeadlock;
	std::string generateID();
	std::string semaphoreName;
	virtual bool isBinarySemaphore() {return false;}
	semaphoreAndLockTracingAndReplay* control;
public:
    	countingSemaphore(int initialPermits, bool traceAndReplay=true);
	~countingSemaphore();
    	void P();
    	void V();
	void V_updateTimestamp();
    	void VP(semaphore* vSem);
};
#endif
