

// Listing1-9. If you want to run this program, comment out the code in
// files Petersons.cpp and testAll.cpp (since they also have a main() method) and 
// delete the block comment operators at the beginning and end of this file, respectively.

#include "sharedVariable.h"
#include "TDThread.h"
#include <iostream>
#include <stdlib.h> 
#include <memory>

std::string IDtoString(int x) {
	char buff[20];
	itoa(x,buff,10); // convert int x into string x
	return buff;
}

sharedVariable<int> s(0); // shared variable s

class communicatingThread: public TDThread {
public:
	// Use a user-defined thread name, which must be unique. This name will appear in ThreadID.txt
	// User-supplied names are more descriptive than the default name generated by TDThread.
	communicatingThread(int ID) : myID(ID), TDThread(std::string("communicatingThread")+IDtoString(ID)) {}
	virtual void* run();
private:
	int myID;
};
void* communicatingThread::run() {
	std::cout << "Thread " << myID << " is running" << std::endl;
	for (int i=0; i<2; i++)		// increment s two times (not 10 million times)
	   s = s + 1;
	return 0;
}
int main() {
	std::auto_ptr<communicatingThread> thread1(new communicatingThread (1));
	std::auto_ptr<communicatingThread> thread2(new communicatingThread (2));
	thread1->start();	thread2->start();
	thread1->join();	thread2->join();
	std::cout << "s: " << s << std::endl;		// the expected final value of s is 4
	return 0;
}
