#ifndef THREADDATA_H
#define THREADDATA_H

#pragma warning(disable:4786) 

#include <stddef.h>
#include "CriticalSectionLock.h"
#include "win32Critical_Section.h"
#include "mutexLocker.h"
#include <map>
#include <string>

struct data {
	int threadID;
	std::string threadName;
	int versionNumber;
	data (int ID, std::string name)
	   : threadID(ID), threadName(name), versionNumber(1) {}
	int getAndIncVersionNumber() {return versionNumber++;}
	int getVersionNumber() {return versionNumber;}
};

class threadData {
public:
	static threadData& instance();
	void addThreadData(unsigned long winThreadID, data d);
	void removeThreadData(unsigned long winThreadID);
	data& getThreadData(unsigned long winThreadID);
private:
	static criticalSectionLock instanceLock;
	threadData(): mainData(0,"main"){} 
	win32Critical_Section dataLock;
	// mapID maps winThreadIDs to thread data (threadId + threadName)
	std::map<unsigned long,data> mapID;
	data mainData; // data for main thread
};
#endif
