public final class ReadersWritersSemaphores {
   public static void main (String args[]) {
   	RWController c = new RWController(); 
		Reader r1 = new Reader(c,1);	Reader r2 = new Reader(c,2); Reader r3 = new Reader(c,3);
		Writer w1 = new Writer(c,1);	Writer w2 = new Writer(c,2);  
		r1.start(); w1.start(); r2.start(); w2.start(); r3.start();
		try {
	    r1.join(); r2.join(); r3.join();
	    w1.join(); w2.join();
		} 
		catch (InterruptedException e) {}
	}
}

final class Reader extends Thread {
	private RWController c;
	private int num;
	Reader (RWController c, int num) {this.c = c; this.num = num; }
	public void run () {
		System.out.println("Reader"+num+" running");
		c.read(num);
		System.out.println("Reader"+num+" finished");
	}
}

final class Writer extends Thread {
	private RWController c;
	private int num;
	Writer (RWController c, int num) {this.c = c; this.num = num; }
	public void run () {		
		System.out.println("Writer"+num+" running");
		c.write(num);
		System.out.println("Writer"+num+" finished");
	}
}

final class RWController{
// R>W.2. This strategy allows concurrent reading and generally gives readers a 
// higher priority than writers. Writers have priority in the following situation: 
// when a reader requests to read, if it is a "lead reader" (i.e., no other reader 
// is reading or waiting), it waits until all writers that arrived earlier have 
// finished writing. This strategy may cause waiting writers to starve.

	int activeReaders = 0; 						// number of active readers
	mutexLock mutex; 								// mutual exclusion for activeReaders 
	// condition queue for waiting writers and the first waiting reader
	binarySemaphore writers_r_que;
	int x=0;       								// x is shared data

	public RWController() {
		mutex = new mutexLock();	
		writers_r_que = new binarySemaphore(1);	
	}

	public void read(int num) {
		mutex.lock();	// block readers if lead reader waiting in writers_r_que
		++activeReaders;
		if (activeReaders == 1) 
		writers_r_que.P();	// block lead reader if a writer is writing
		mutex.unlock();

		//System.out.println("Reader" + num + " reading");
		//try{Thread.sleep(10);}catch(InterruptedException e){}; 

		mutex.lock();
		--activeReaders;	
		if (activeReaders == 0) 
		writers_r_que.V();	// allow waiting writers, if any, to write
		mutex.unlock();			
	}				

	public void write(int num) {
		writers_r_que.P();	// block until no readers are reading or waiting and 
			
		//System.out.println("Writer" + num + " writing");
		//try{Thread.sleep(10);}catch(InterruptedException e){}; 
		
		writers_r_que.V();	// signal lead reader or a writer at the front of the queue
	}
}


