class countingSemaphore {
	private int permits = 0;
	// provides mutual exclusion for permits
	private binarySemaphore mutex = new binarySemaphore(1);		
	// condition queue for threads blocked in P 
	private binarySemaphore delayQ = new binarySemaphore(0);	 
	public void P() {
		mutex.P();
		--permits;
		if (permits < 0){ 
			mutex.V(); 
			delayQ.P();
		} 
		else 
			mutex.V();
	}
	public void V() {
		mutex.P();
		++permits;
		if (permits <= 0) 
			delayQ.V();
		mutex.V();
	}
}

// Listing 3.14 Implementing counting semaphores by using P() and V() 
// operations on binary semaphores.

