public final class boundedBuffer {
	public static void main (String args[]) {
	final int size = 3;
	Buffer b = new Buffer(size);	
	mutexLock mutexD = new mutexLock();	// exclusion for Producers
	mutexLock mutexW = new mutexLock();	// exclusion for Consumers
	countingSemaphore emptySlots = new countingSemaphore(size);
	countingSemaphore fullSlots = new countingSemaphore(0);
	Producer pl = new Producer (b,emptySlots,fullSlots,mutexD,1);
	Producer p2 = new Producer (b,emptySlots,fullSlots,mutexD,2);
	Consumer cl = new Consumer (b,emptySlots,fullSlots,mutexW,1);
	Consumer c2 = new Consumer (b,emptySlots,fullSlots,mutexW,2);
	pl.start(); cl.start();
	p2.start(); c2.start();
	}
}
final class Producer extends Thread {
	private Buffer b = null;
	private int num;
	private countingSemaphore emptySlots;
	private countingSemaphore fullSlots;
	private mutexLock mutexD;
	Producer (Buffer b, countingSemaphore emptySlots, 
	countingSemaphore fullSlots, mutexLock mutexD, int num) {
	this.b = b; 	this.num = num;
	this.emptySlots = emptySlots; this.fullSlots = fullSlots; 
	this.mutexD = mutexD;
	}
	public void run () {
	System.out.println ("Producer  Running");
	for (int i = 0; i < 3; i++) {	
	emptySlots.P();	
	mutexD.lock();
	b.deposit(i);
	System.out.println ("Producer # " + num + " deposited " + i);
	System.out.flush();
	mutexD.unlock();
	fullSlots.V();
	}
 	}
}
final class Consumer extends Thread {
	private Buffer b;
	private int num;
	private countingSemaphore emptySlots;
	private countingSemaphore fullSlots;
	private mutexLock mutexW;
	Consumer (Buffer b, countingSemaphore emptySlots, 
	countingSemaphore fullSlots, mutexLock mutexW, int num) {
	this.b = b; this.num = num;
	this.emptySlots = emptySlots; this.fullSlots = fullSlots; 
	this.mutexW = mutexW;
	}
	public void run () {
  			System.out.println ("Consumer running");
  			int value = 0;
 			for (int i = 0; i < 3; i++) {
	fullSlots.P();
	mutexW.lock();
	value = b.withdraw();
	System.out.println ("Consumer # " + num + " withdrew " + value);
	System.out.flush();
	mutexW.unlock();
	emptySlots.V();
	}
	}
}
final class Buffer {
	private int[] buffer = null;
	private int in = 0, out = 0;
	private int capacity;
	public Buffer(int capacity) {
	this.capacity = capacity;
	buffer = new int[capacity];
	}
   	public int withdraw () {
	int value = buffer[out];		
	out = (out + 1) % capacity; // out is shared by consumers
	return value;
    	}
    	public void deposit (int value) {
	buffer[in] = value;			
	in = (in + 1) % capacity; // in is shared by producers
	}
}

	//Listing 3.17 Java bounded buffer using semaphores and locks.

