public final class resourceAllocation {

    public static void main (String args[]) {
		// provides mutual exclusion for count and waiting
		countingSemaphore mutex = new countingSemaphore(1);
		// used as a queue of blocked threads
		countingSemaphore resourceAvailable = new countingSemaphore(0);
		myThread T1 = new myThread(mutex,resourceAvailable);
		myThread T2 = new myThread(mutex,resourceAvailable);
		myThread T3 = new myThread(mutex,resourceAvailable);	
		T1.start(); T2.start(); T3.start();
    }
}

final class myThread extends Thread {
	 private static int count = 2;	// number of available resources
	 private static int waiting = 0;	// number of waiting threads
    private countingSemaphore mutex;
    private countingSemaphore resourceAvailable;
    myThread(countingSemaphore mutex, countingSemaphore resourceAvailable) {
		this.mutex = mutex;
		this.resourceAvailable = resourceAvailable;
    }
    public void run () {
		mutex.P();						// enter the critical section			
		if (count>0) {					// is a resource available?
			count--;						// one less resource available
			mutex.V();					// exit the critical section
		}
		else {
			waiting++;					// one more waiting thread
			mutex.V();					// exit the critical section
			resourceAvailable.P();	// wait for a resource
		}
		/* use the resource */
		mutex.P();						// enter the critical section
		if (waiting>0) {				// are there waiting threads?
			--waiting;					// one less waiting thread
			resourceAvailable.V();	// notify a waiting thread
		}
		else count++;					// return a resource to the pool
		mutex.V();
    }
}

// Listing 3.2 An alternate solution to the resource allocation problem.

