#include "mutexLock.h"
#include <iostream>

mutexLock::mutexLock(): owner(0), count(0), mutex(1) {}
mutexLock::~mutexLock() {}
void mutexLock::lock() {
	mutex.P();
	if (count == 0) { count = 1; owner = GetCurrentThreadId(); }
	else if (owner == GetCurrentThreadId()) {++count;}
	else  { // block threads
	win32Semaphore* s = pool.acquire();
	waitingLock.push(s);	// otherwise append semaphore
	mutex.V();	// release mutual exclusion before blocking
	s->P();	// call to P() returns holding mutex since unlock() doesn't release it
	count = 1;	
	owner = GetCurrentThreadId();
	pool.release(s);
	}
	mutex.V();
}

void mutexLock::unlock() {
	mutex.P();
	if (owner != 0) {
		if (owner == GetCurrentThreadId()) {
	--count;
	if (count == 0) {
	owner = 0;
	if (!waitingLock.empty()) { // any threads waiting for the lock?
	// wakeup longest waiting thread
	win32Semaphore* oldest = waitingLock.front();		waitingLock.pop();
	oldest->V();
	// mutex not released so oldest thread completes P() next
	return;
	}
	else { mutex.V(); return; }
	}
	else { mutex.V(); return; }
	}
		else {
	std::cout << "unlock failed at line " << __LINE__ << " in " 
	<< __FILE__  << " with error: Calling thread is not the owner." 
	<< std::endl; exit(1);
	}
	}
	else {
		std::cout << "unlock failed at line " << __LINE__ << " in " << __FILE__ 
	<< " with error: Calling thread is not the owner." << std::endl; 
	exit(1);
	}
}


//Listing 3.23 Class mutexLock.
