
#include "semaphorePool.h"
#include "win32Semaphore.h"
#include "mutexlocker.h"
#include <iostream>

semaphorePool::semaphorePool() {
	for (int i = 0; i < initialPoolSize; i++) {
		win32Semaphore* s = new win32Semaphore(0);
		pool.push(s);
	}
	poolSize = initialPoolSize;
}

semaphorePool::~semaphorePool() {
	while (!pool.empty()) {
		win32Semaphore* s = pool.front();
		pool.pop();
		delete s;
	}
	//delete pool;
}
 

win32Semaphore* semaphorePool::acquire() {
	mutexLocker<win32Critical_Section> mutex(criticalSection); 
	win32Semaphore* s;
	if (!pool.empty()) {
		s = pool.front();
		pool.pop();
	}
	else {
		//std::cout << "increase poolSize to " << (poolSize+1) << std::endl;
		s = new win32Semaphore(0);
		poolSize++;
	}	 
	return s;
}

void semaphorePool::release (win32Semaphore* s) {
	mutexLocker<win32Critical_Section> mutex(criticalSection); 
	pool.push(s);
}
