#ifndef SEMAPHOREPOOL_H
#define SEMAPHOREPOOL_H
#include <queue>
#include "win32Semaphore.h"
#include "win32Critical_Section.h"

const int initialPoolSize = 1;
class semaphorePool {
public:
	semaphorePool();
	~semaphorePool();
	win32Semaphore* acquire();
	void release(win32Semaphore* s);
private:
	win32Critical_Section criticalSection;
	std::queue<win32Semaphore*> pool;
	int poolSize; // total number of semaphores created for pool
};

#endif
