
#ifndef MUTEXLOCK_H
#define MUTEXLOCK_H

#include <windows.h>

#include "semaphorepool.h"
#include "win32semaphore.h"

#include <queue>

class mutexLock {
// simple class for lock/unlock on a mutex lock
private:
  semaphorePool pool;		// pool of semaphores
  std::queue<win32Semaphore*> waitingLock; // queue of threads blocked on lock()
  unsigned long owner;
  int count;
  win32Semaphore mutex;
public:
  void lock();
  void unlock();
  mutexLock();
  ~mutexLock();
};

#endif


