#ifndef SEMAPHOREPOOL_H
#define SEMAPHOREPOOL_H
#include <queue>
#include "win32Semaphore.h"
#include "win32Critical_Section.h"

class queueWrapper {
public:
  win32Semaphore* front() { return pool.front(); }
  void pop() { pool.pop();}
  void push(win32Semaphore* s) {pool.push(s);}
  bool empty() { return pool.empty();}
private:
	std::queue<win32Semaphore*> pool;
};

const int initialPoolSize = 1;
class semaphorePool {
public:
	semaphorePool();
	~semaphorePool();
	win32Semaphore* acquire();
	void release(win32Semaphore* s);
private:
	win32Critical_Section criticalSection;
	queueWrapper* pool;
	int poolSize; // total number of semaphores created for pool
};

#endif
