	#include <pthread.h>
	#include <semaphore.h>
	#include <iostream>
   #include <stdio.h>

sem_t s;

void* Thread1(void* arg) {
	int status;
	status = sem_wait(&s); 
	if (status !=0) {std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;perror("sem_wait failed");exit(status);}
	std::cout << "thread 1 in critical section" << std::endl;
	status = sem_post(&s);
	if (status !=0) {std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;perror("sem_post failed");exit(status);}
	return NULL;
}

void* Thread2(void* arg) {
	int status;
	status = sem_wait(&s); 
	if (status !=0) {std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;perror("sem_wait failed");exit(status);}
	std::cout << "thread 2 in critical section" << std::endl;
	status = sem_post(&s);
	if (status !=0) {std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;perror("sem_post failed");exit(status);}
	return NULL;
}

int main() {
	pthread_t threadArray[2];			// array of thread IDs
	int status;                      // error code
	pthread_attr_t threadAttribute;

	// initialize semaphore s
	status = sem_init(&s,0,1);
	if (status !=0) {std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;perror("sem_init failed");exit(status);}

	status = pthread_attr_init(&threadAttribute);		// initialize the attribute object
	if (status != 0) {std::cout << "pthread_attr_init failed at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status); }		
	status = pthread_attr_setscope(&threadAttribute, PTHREAD_SCOPE_SYSTEM);
	if (status != 0) {std::cout << "pthread_attr_init failed at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status); }


// Create two threads and store their IDs in array threadArray
	status = pthread_create(&threadArray[0], &threadAttribute, Thread1, (void*) 1L);
	if (status != 0) {
		std::cout << "pthread_create failed at " << __FILE__ << ":" << __LINE__ << " - " << strerror(status) << 
      std::endl; exit(status);
	}
	status = pthread_create(&threadArray[1], &threadAttribute, Thread2, (void*) 2L);
	if (status != 0) {
		std::cout << "pthread_create failed at " << __FILE__ << ":" << __LINE__ << " - " << strerror(status) << 
      std::endl; exit(status);
	}

	status = pthread_attr_destroy(&threadAttribute);
	if (status != 0) {std::cout << "pthread_attr_destroy failed at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status);  }

	// Wait for threads to finish
	status = pthread_join(threadArray[0],NULL);	
	if (status != 0) { 
		std::cout << "pthread_join failed at " << __FILE__ << ":" << __LINE__ << " - " << strerror(status) << 
      std::endl; exit(status);
	}
	status = pthread_join(threadArray[1],NULL);
	if (status != 0) { 
		std::cout << "pthread_join failed at " << __FILE__ << ":" << __LINE__ << " - " << strerror(status) << 
      std::endl; exit(status);
	}

	// Destroy semaphore s
	status = sem_destroy(&s);
	if (status !=0) {std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;perror("sem_destroy failed");exit(status);}

}

