#include "POSIXSemaphore.h"
#include <semaphore.h>
#include <iostream>
#include <stdio.h>



POSIXSemaphore::POSIXSemaphore (int initial) : permits(initial) {
	int status = sem_init(&s, 0, initial);	// assume semaphore is accessed by the threads in a single process
   if (status != 0) {
		std::cout << __FILE__ << ":" << __LINE__ << " - " << flush; 
		perror("sem_init failed"); exit(status);
   }

}
POSIXSemaphore:: ~ POSIXSemaphore () { 
	int status = sem_destroy(&s);
   if (status != 0) {
		std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;
		perror("sem_destroy failed"); exit(status);
	}
 }
void POSIXSemaphore::P() {
	int status = sem_wait(&s);
   if (status != 0) {
		std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;
		perror("sem_wait failed"); exit(status);
	}
}
void POSIXSemaphore::V() {
	int status = sem_post(&s);
   if (status != 0) {
		std::cout << __FILE__ << ":" << __LINE__ << " - " << flush;
		perror("sem_post failed"); exit(status);
	}
}




