#include <pthread.h>
#include "POSIXSemaphore.h"
#include <iostream>

POSIXSemaphore s(1);

void* Thread1(void* arg) {
	s.P();
	std::cout << "thread 1 in critical section" << std::endl;
	s.V();
	return NULL;
}

void* Thread2(void* arg) {
	s.P();
	std::cout << "thread 2 in critical section" << std::endl;
	s.V();
	return NULL;
}

int main() {
	pthread_t threadArray[2];			// array of thread IDs
	int status;								// error code
	pthread_attr_t threadAttribute;

	status = pthread_attr_init(&threadAttribute);		// initialize the attribute object
	if (status != 0) {std::cout << "pthread_attr_init failed at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status); }		
	status = pthread_attr_setscope(&threadAttribute, PTHREAD_SCOPE_SYSTEM);
	if (status != 0) {std::cout << "pthread_attr_init failed at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status); }


	// Create two threads and store their IDs in array threadArray
	status = pthread_create(&threadArray[0], &threadAttribute, Thread1, (void*) 1L);
   if (status != 0) {
		std::cout << "Error creating thread at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status);
	}
	status = pthread_create(&threadArray[1], &threadAttribute, Thread2, (void*) 2L);
   if (status != 0) {
		std::cout << "Error creating thread at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status);
	}
	status = pthread_attr_destroy(&threadAttribute);
	if (status != 0) {std::cout << "pthread_attr_destroy failed at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status);  }

	// Wait for threads to finish
	status = pthread_join(threadArray[0],NULL);	
	status = pthread_join(threadArray[1],NULL);
   if (status != 0) {
		std::cout << "Error creating thread at " << __FILE__ << ":" << __LINE__ << std::endl; exit(status);
	}

}
