public final class boundedBuffer {

    public static void main (String args[]) {
		Buffer b = new Buffer(2);
		Producer p1 = new Producer (b);
		Consumer c1 = new Consumer (b);
		p1.start(); c1.start();
    }
}

final class Producer extends Thread {
    private Buffer b;
    Producer (Buffer b) {
		this.b = b;
    }
    public void run () {
		for (int i = 0; i < 3; i++) {
	    b.deposit(i);
	    System.out.println ("Producer deposited " + i);
		}
    }
}

final class Consumer extends Thread {
    private Buffer b;
    Consumer (Buffer b) {
		this.b = b;
    }

	public void run () {
		int item = 0;
		for (int i = 0; i < 3; i++) {
	   	item = b.withdraw();
	    	System.out.println ("Consumer withdrew " + item);
		}
	}
}

final class Buffer {
    private int n = 0;
    private int[] buffer = null;
    private int in = 0, out = 0;

    private countingSemaphore fullSlots;
    private countingSemaphore emptySlots;

    public Buffer(int n) {
		this.n = n;
		buffer = new int[n];
		emptySlots = new countingSemaphore(n);
		fullSlots = new countingSemaphore(0);
    }

    public void deposit(int item) {
  		emptySlots.P();
		buffer[in] = item;
		in = (in + 1) % n;
		fullSlots.V();
    }

    public int withdraw() {
		int item;
		fullSlots.P();
		item = buffer[out];
		out = (out + 1) % n;
		emptySlots.V();

		return item;
    }
}
