#ifndef SEMAPHOREIDGENERATOR_H
#define SEMAPHOREIDGENERATOR_H

#pragma warning(disable:4786) 
#include <stddef.h>
#include "criticalSectionLock.h"
#include "win32Critical_Section.h"
#include "mutexLocker.h"
#include <map>
#include <string>
#include <fstream>
#include <iostream>

class InvalidSemaphoreName { // extends InvalidIDException {
public:
	InvalidSemaphoreName() { }
	InvalidSemaphoreName(std::string msg_): msg(msg_) { } // super(msg);}
private:
  std::string msg; 
};

class SemaphoreIDGenerator {
private:
	std::map<std::string,int> names;
	// when replay or test, use IDs generated during trace (not new IDs).
	static criticalSectionLock instanceLock;
	win32Critical_Section dataLock; 
	std::ofstream outputSemaphoreIDs;
	SemaphoreIDGenerator();
	bool containsName(std::string stringID);
	void putName(std::string name, int num);
	void putUserName(std::string name, int num);
	int getNum(std::string name);
public:
	static SemaphoreIDGenerator& instance();
	std::string getID(std::string stringID);
	std::string getIDFromUserName(std::string userName);
};
#endif
