#ifndef THREAD_H
#define THREAD_H
#pragma warning(disable:4786) 
#include "runnable.h"
#include <windows.h>
#include <memory>
#include <iostream>
				
class Thread {
public:
	Thread(std::auto_ptr<Runnable> runnable_);
	Thread();
	virtual ~Thread();
	void start();	// threads are created in suspended state; this starts them
	void* join();
private:
	HANDLE hThread;
	unsigned winThreadID; // Win32 thread ID
	std::auto_ptr<Runnable> runnable;
	Thread(const Thread&);
	const Thread& operator= (const Thread&);
	HANDLE completionEvent;
	void setCompleted();
	void* result;			// stores return value of run()
	static unsigned WINAPI startThreadRunnable(LPVOID pVoid);
	virtual void* run() {return 0;}
	static unsigned WINAPI startThread(LPVOID pVoid);
	void PrintError(LPTSTR lpszFunction,LPSTR fileName, int lineNumber);
};
#endif
