
#include "controlConditionVariable.h"
#include <iostream>

controlConditionVariable::controlConditionVariable(controlMonitor* mon)
: threadQueue(0,false), m(*mon), numWaitingThreads(0) {}


void controlConditionVariable::signalC() {
	if (numWaitingThreads > 0) {
		++(m.reentryCount);
	    m.reentry.VP(&threadQueue);
		--(m.reentryCount);
   	}
}
	 	 
void controlConditionVariable::signalC_and_exitMonitor() {
	if (numWaitingThreads > 0) {
		threadQueue.V();
	}
	else if ((m.reentryCount) > 0)
		m.reentry.V();
	else
		m.mutex.V();
}

void controlConditionVariable::waitC() {
	numWaitingThreads++;
	if ((m.reentryCount) > 0)
		threadQueue.VP(&(m.reentry));
	else
		threadQueue.VP(&(m.mutex));
	--numWaitingThreads;
}

bool controlConditionVariable::empty() {
	return (numWaitingThreads == 0);
}

int controlConditionVariable::length() {
	return numWaitingThreads;
}
