#ifndef LOCKDATA_H
#define LOCKDATA_H

#pragma warning(disable:4786) 
#include <stddef.h>
#include "criticalSectionLock.h"
#include "win32Critical_Section.h"
#include "mutexLocker.h"
#include <string>
#include <set>
#include <map>


struct ltms {
	bool operator()(const unsigned long u1, const unsigned long u2) const {
		return u1 < u2;
	}
};


class lockData {
public:
	static lockData& instance();
	void addLocked(int ID);
	void removeLocked(int ID);
	std::multiset<int> getLocked(unsigned long currentThread);
private:
	static criticalSectionLock instanceLock;
	lockData() : dataLock() {} 
	win32Critical_Section dataLock;
	std::map<unsigned long, std::multiset<int>, ltms> locked;
	// mapID maps winThreadIDs to threadIDs
};
#endif


