#ifndef SHAREDVARIABLECONTROLLER_H
#define SHAREDVARIABLECONTROLLER_H

#pragma warning(disable:4786) 
#include "controlMonitor.h"
#include "controlConditionVariable.h"
#include "criticalSectionLock.h"
#include <list>
#include <map>
#include <fstream>
#include <string>
#include <iostream>
#include <vector>
#include <string>

class event {
public:
	int threadID;
	int version;
	int totalReaders;
	event() {};
	event(int threadID_, int version_, int totalReaders_)
		: threadID(threadID_), version(version_), totalReaders(totalReaders_) {}
	friend std::ostream& operator<<(std::ostream& out, const event& e);
	friend std::istream& operator>>(std::istream& out, event& e);
};

class sharedVariableController : public controlMonitor {
public:
	sharedVariableController(std::string traceFileName);
	~sharedVariableController();
	void traceStartRead();
	void traceEndRead();
	void traceStartWrite();
	void traceEndWrite();
	void requestWritePermit();
	void releaseWritePermit();
	void requestReadPermit();
	void releaseReadPermit();
private: 
	enum { maxThreads = 10 };
	controlConditionVariable* myTurn;
	std::queue<char> waiting;
	bool writing;
	int activeReaders;
	int totalReaders;
	int requiredReaders;
	int version;
	int maxThreadID;
	bool traceFileNotOpened; // initialy true; true until traceFile opened on first trace event
	std::string traceFileName;
	std::map<int, std::list<int> > requestingReadersMap;
	std::map<int, int> requestingWritersMap;
	controlConditionVariable** versionNumber; //[maxThreads];
	void setupTrace();
	void trace(event e);
	void inputSynSequence();
	int getNextReadEvent(int ID);
	void getNextWriteEvent(int ID, int& nextVersion, int& requiredReaders);
	std::ofstream traceFile;
	std::ifstream replayFile;
	std::vector<event> eventList;
	std::vector<std::list<event> > sequences;
	int mode;
};

#endif
