#ifndef SHAREDVARIABLEIDGENERATOR_H
#define SHAREDVARIABLEIDGENERATOR_H

#pragma warning(disable:4786) 
#include <stddef.h>
#include "criticalSectionLock.h"
#include "win32Critical_Section.h"
#include "mutexLocker.h"
#include <map>
#include <string>
#include <fstream>
#include <iostream>

class InvalidVariableName {
public:
	InvalidVariableName() { }
	InvalidVariableName(std::string msg_): msg(msg_) { }
private:
	std::string msg; 
};

class sharedVariableIDGenerator {
private:
	std::map<std::string,int> names;
	// when replay or test, use IDs generated during trace (not new IDs).
    	static criticalSectionLock instanceLock;
	win32Critical_Section dataLock; 
	std::ofstream outputVariableIDs;
	sharedVariableIDGenerator();
	//TBD
  	//~ThreadIDGenerator(); // close files?
	//TBD
	bool containsName(std::string stringID);
	void putName(std::string name, int num);
	void putUserName(std::string name, int num);
	int getNum(std::string name);
public:
	static sharedVariableIDGenerator& instance();
	std::string getID(std::string stringID);
	std::string getIDFromUserName(std::string userName);
};
#endif
