public final class countingSemaphore {
	private int permits = 0; int waitCount = 0; int notifyCount=0;
	public countingSemaphore(int initialPermits) {
		if (initialPermits>0) permits = initialPermits;
	}
	synchronized public void P() throws InterruptedException {
		if (permits <= waitCount) {
			waitCount++;	// one more thread is waiting
			try { 
				do { wait(); } 	// spurious wakeups do not increment
				while (notifyCount == 0);	//    notifyCount
			} 
			finally { waitCount--; }	// one waiting thread notified or interrupted
			notifyCount--;	// one notification has been consumed
		}
		else {
			if (notifyCount > waitCount)	// if some notified threads were
			notifyCount--;	// 	   interrupted, adjust notifyCount
		}
			permits--;
	}

	synchronized public void V() {
		permits++;
		if (waitCount > notifyCount) { // if there are waiting threads yet to be 
			notifyCount++;	//     notified, notify one thread
			notify();
		}
	}
}
//Listing 4.11 Java Class countingSemaphore that handles interrupts and spurious wakeups.

