final class boundedBuffer {
	private int fullSlots=0; private int capacity = 0; 
	private int[] buffer = null; private int in = 0, out = 0;
	public boundedBuffer(int bufferCapacity) {
	capacity = bufferCapacity; buffer = new int[capacity];
	}
	public synchronized void deposit (int value) {
	while (fullSlots == capacity) // assume no interrupts are possible
	try { wait(); } catch (InterruptedException ex) {} 
	buffer[in] = value;
	in = (in + 1) % capacity;
	if (fullSlots++ == 0)	// note the use of post-increment.
	notifyAll();	 // it is possible that Consumers are waiting for "not empty"
    	}
	public synchronized int withdraw () {
	int value = 0;
	while (fullSlots == 0)	// assume no interrupts are possible
	try { wait(); } catch (InterruptedException ex) {} 
	value = buffer[out];
	out = (out + 1) % capacity;
	if (fullSlots-- == capacity)	// note the use of post-decrement.
	notifyAll(); // it is possible that Producers are waiting for "not full"
	return value;
	}
}

//Listing 4.13 Java monitor boundedBuffer.

