public final class binarySemaphore2 {
	int vPermits = 0;
	int pPermits = 0;
	Object allowP = null;	// queue of threads waiting in P()
	Object allowV = null;	// queue of threads waiting in V()
	public binarySemaphore2(int initialPermits) {  
		if (initialPermits != 0 && initialPermits != 1) throw new 
			IllegalArgumentException("initial binary semaphore value must be 0 or 1");
		pPermits = initialPermits;	// 1 or 0
		vPermits = 1 - pPermits;	// 0 or 1
		allowP = new Object();
		allowV = new Object();
	}
	public void P() {
		synchronized (allowP) {
			--pPermits;
			if (pPermits < 0) // assume no interrupts are possible
			try { allowP.wait(); } catch (InterruptedException e) {} 
		}
		synchronized (allowV) { 
			++vPermits;
			if (vPermits <=0) 
			allowV.notify();	// signal thread waiting in V()
		}
	}

		public void V() {
			synchronized (allowV) {
				--vPermits;
				if (vPermits < 0) // assume no interrupts are possible
				try { allowV.wait(); } catch (InterruptedException e) {} 
			}
			synchronized (allowP) {
				++pPermits;
				if (pPermits <= 0) 
				allowP.notify();	// signal thread waiting in P()
			}
	}
}

//Listing 4.14 Java class binarySemaphore2.	

