public class monitorSU {
// Monitor Toolbox that uses VP() operation and SU signaling

	private binarySemaphore mutex = new binarySemaphore(1);
	private binarySemaphore reentry = new binarySemaphore(0);
	private int reentryCount = 0;

	protected final class conditionVariable {
		private countingSemaphore threadQueue = new countingSemaphore(0);
		private int numWaitingThreads = 0;

		public void signalC() {
			if (numWaitingThreads > 0) {
				++reentryCount;
				reentry.VP(threadQueue);
				--reentryCount;
   		}
		}

		public void signalC_and_exitMonitor() {
			if (numWaitingThreads > 0)
				threadQueue.V();
			else if (reentryCount > 0)
    			reentry.V();
 			else
    			mutex.V();
   	}			

		public void waitC() {
   		numWaitingThreads++;
			if (reentryCount > 0)
				threadQueue.VP(reentry);
			else
				threadQueue.VP(mutex);
			--numWaitingThreads;
		}

		public boolean empty() {
 			return (numWaitingThreads == 0);
		}

		public int length() {
			return numWaitingThreads;
		}
	}


	public void enterMonitor() {
		mutex.P();
	}

	public void exitMonitor() {	
		if (reentryCount > 0)
    		reentry.V();
 		else
    		mutex.V();
	}


}

