class r_gt_w_1SU extends monitorSU { 
	int readerCount = 0;	// number of active readers 
	boolean writing = false;	// true if a writer is writing
	conditionVariable readerQ = new conditionVariable(); 
	conditionVariable writerQ = new conditionVariable();
	    
	public void startRead() {
		enterMonitor();
		if (writing)	// readers must wait if a writer is writing
			readerQ.waitC();
		++readerCount;
		readerQ.signalC_and_exitMonitor();	// continue cascaded wakeup of readers
	}
	public void endRead() {
		enterMonitor();
		--readerCount;
		if (readerCount == 0)	
			writerQ.signalC_and_exitMonitor();	// signal writer if there are no more readers reading 
		else exitMonitor();
	}
	public void startWrite() {
		enterMonitor();
		// writers wait if a writer is writing, or a reader is reading or waiting, or the 
		// writer is barging
		while (readerCount > 0 || writing || !readerQ.empty()) 
			writerQ.waitC();
		writing = true;
		exitMonitor();
	}
	public void endWrite() {
		enterMonitor();
		writing = false;
		if (!readerQ.empty()) {	// priority is given to waiting readers
			readerQ.signalC_and_exitMonitor();	// start cascaded wakeup of readers
		}
		else 
			writerQ.signalC_and_exitMonitor();
	}	
}

//Listing 4.18 Class r_gt_w_1SU  allows concurrent reading and gives readers a higher priority than writers.

