public final class boundedBufferSC {

	public static void main (String args[]) {
		BufferMonitor b1 = new BufferMonitor(2);
		ProducerMonitor p1 = new ProducerMonitor (b1);
		ConsumerMonitor c1 = new ConsumerMonitor (b1);
		p1.start();c1.start(); 
	}
}

final class ProducerMonitor extends Thread {

	private BufferMonitor b;
	private int num;

	ProducerMonitor (BufferMonitor b) {
 		this.b = b;
 	}

	public void run () {
		for (int i = 0; i < 1; i++) {
			b.deposit(i);
			System.out.println ("Producer deposited " + i);
		}
	}
}

final class ConsumerMonitor extends Thread {

	private BufferMonitor b;
	
	ConsumerMonitor (BufferMonitor b) {
		this.b = b;
	}

	public void run () {
 		int value = 0;
		for (int i = 0; i < 1; i++) {
			value = b.withdraw();
			System.out.println ("Consumer withdrew " + value);
		}
	}
}

final class BufferMonitor extends monitorSC {
	private int fullSlots = 0; 			// # of full slots in the buffer
	private int capacity = 0;
   private int[] buffer = null;
   private int in = 0, out = 0;

	private conditionVariable notFull;
	private conditionVariable notEmpty;

	public BufferMonitor(int capacity) {
		this.capacity = capacity;
		buffer = new int[capacity];
		notFull = new conditionVariable();
		notEmpty = new conditionVariable();
	}

	public void deposit(int value) {
		enterMonitor();
		while (fullSlots == capacity)  {
			notFull.waitC();
		}
		buffer[in] = value;
      in = (in + 1) % capacity;
		++fullSlots;
		notEmpty.signalCall();
		exitMonitor();
}

	public int withdraw() {
		enterMonitor();
		int value;
		while (fullSlots == 0) {
			notEmpty.waitC();
		}
		value = buffer[out];
      out = (out + 1) % capacity;
		--fullSlots;
		notFull.signalCall();
		exitMonitor();
		return value;
	}
}
