#ifndef BINARYSEMAPHORE_H
#define BINARYSEMAPHORE_H

#pragma warning(disable:4786) 
#include "semaphore.h"
#include "win32semaphore.h"
#include "semaphorePool.h"
#include <windows.h>
#include "criticalsectionlock.h"
#include <queue>
#include <string>

class binarySemaphore : public semaphore {
// a FIFO binary semaphore
private:
	std::queue<waitRecord> waitingP; // queue of threads blocked on P
	std::queue<waitRecord> waitingV; // queue of threads blocked on V
	bool doP();
	semaphorePool pool; // resource pool of semaphores
	int numControllers;
	virtual bool isBinarySemaphore() {return true;}
public:
	binarySemaphore(int initialPermits);
	~binarySemaphore();
	void P();
	void V();
	void VP(semaphore* vSem);
};
#endif
