
#include "conditionVariable.h"
#include "monitorsc.h"


conditionVariable::conditionVariable(monitorSC* mon) : threadQueue(0), m(*mon), 
numWaitingThreads(0) { }

conditionVariable::conditionVariable(monitorSC* mon, std::string conditionName_) 
: threadQueue(0), m(*mon), numWaitingThreads(0), conditionName(conditionName_) {}

	
void conditionVariable::signalC() {
	if (numWaitingThreads > 0) {
        --numWaitingThreads;
	    threadQueue.V();
   	}
}

void conditionVariable::signalCall() {
	while (numWaitingThreads > 0) {
        --numWaitingThreads;
	    threadQueue.V();
   	}
}	   	   

void conditionVariable::waitC() {
	numWaitingThreads++;
	threadQueue.VP(&(m.mutex));
	m.mutex.P();
}

bool conditionVariable::empty() {
	return (numWaitingThreads == 0);
}

int conditionVariable::length() {
	return numWaitingThreads;
}

