
#include "conditionVariable.h"
#include <iostream>

conditionVariable::conditionVariable(monitorSU* mon)
: threadQueue(0), m(*mon), numWaitingThreads(0) {}


void conditionVariable::signalC() {
	if (numWaitingThreads > 0) {
		++(m.reentryCount);
	    m.reentry.VP(&threadQueue);
		--(m.reentryCount);
   	}
}
	 	 
void conditionVariable::signalC_and_exitMonitor() {
	if (numWaitingThreads > 0) {
		threadQueue.V();
	}
	else if ((m.reentryCount) > 0)
		m.reentry.V();
	else
		m.mutex.V();
}

void conditionVariable::waitC() {
	numWaitingThreads++;
	if ((m.reentryCount) > 0)
		threadQueue.VP(&(m.reentry));
	else
		threadQueue.VP(&(m.mutex));
	--numWaitingThreads;
}

bool conditionVariable::empty() {
	return (numWaitingThreads == 0);
}

int conditionVariable::length() {
	return numWaitingThreads;
}
