#ifndef THREAD_H
#define THREAD_H
#pragma warning(disable:4786) 
#include "runnable.h"
#include <windows.h>
#include <iostream>
#include <string>
				
class Thread {
public:
	Thread(Runnable*  runnable_, const std::string tName = "", size_t stackSize_=0);
	Thread(const std::string tName = "",size_t stackSize_=0);
    virtual ~Thread();

    void start();	// threads are created in suspended state; this starts them
    unsigned long getThreadID(); // returns Win32 ID
	const std::string getThreadName(); // returns threadName

    // Abnormally terminates a different thread. Should be avoided
    void exit(int code); // terminates this thread; called by other thread
    static unsigned long currentThreadID(); // WIN32 ID of current thread
    static void exitCurrentThread(int code); // exits calling thread
	void join();
private:
    HANDLE hThread;
    DWORD winThreadID; // Win32 thread ID
    Runnable* runnable;
	Thread(const Thread&);
    const Thread& operator= (const Thread&);
	HANDLE completionEvent;
	void setCompleted();
	std::string threadName;
	size_t stackSize;
	int generateID();
		
	static DWORD WINAPI startThreadRunnable(LPVOID pVoid);
	virtual void run() {}
	static DWORD WINAPI startThread(LPVOID pVoid);

    };
#endif
