public final class boundedBuffer {

	public static void main (String args[]) {
		Buffer b1 = new Buffer(3);
		Producer pl = new Producer (b1);
		Consumer cl = new Consumer (b1);
		cl.start();
		pl.start();
	}
}

final class Producer extends Thread {

	private Buffer b;
	private int num;
	private int ID;

	Producer (Buffer b) {
 		this.b = b;
 	}

	public void run () {
		for (int i = 0; i < 3; i++) {
			b.deposit(i);
			System.out.println ("Producer deposited " + i);
		}
	}
}

final class Consumer extends Thread {

	private Buffer b;

	Consumer (Buffer b) {
		this.b = b;
	}

	public void run () {
 		int value = 0;
		for (int i = 0; i < 3; i++) {
			value = b.withdraw();
			System.out.println ("Consumer withdrew " + value);
		}
	}
}

final class Buffer extends monitorSC {
	private int fullSlots = 0; 			// # of full slots in the buffer
	private int capacity = 0;
   private int[] buffer = null;
   private int in = 0, out = 0;

	private conditionVariable notFull;
	private conditionVariable notEmpty;

	public Buffer(int capacity) {
		this.capacity = capacity;
		buffer = new int[capacity];
		notFull = new conditionVariable(); 
		notEmpty = new conditionVariable();
	}

	public void deposit(int value) {
		enterMonitor();
		while (fullSlots == capacity) 
			notFull.waitC();
		buffer[in] = value;
      in = (in + 1) % capacity;
		++fullSlots;
		notEmpty.signalC();
		exitMonitor();
}

	public int withdraw() {
		enterMonitor();
		int value;
		while (fullSlots == 0) 
			notEmpty.waitC();
		value = buffer[out];
      out = (out + 1) % capacity;
		--fullSlots;
		notFull.signalC();
		exitMonitor();
		return value;
	}
}
