public final class diningPhilosopher1  {

    public static void main (String args[]) {
		diningPhilosopher1Monitor d = new diningPhilosopher1Monitor();
		Philosopher p0 = new Philosopher (d, 0);
		Philosopher p1 = new Philosopher (d, 1);
		Philosopher p2 = new Philosopher (d, 2);
		Philosopher p3 = new Philosopher (d, 3);
		Philosopher p4 = new Philosopher (d, 4);
		p0.start(); p1.start(); p2.start();	p3.start();	p4.start();
}
}

final class Philosopher extends Thread {
	private diningPhilosopher1Monitor d;
	private int num;
	Philosopher (diningPhilosopher1Monitor d, int num) {
		this.d = d;
		this.num = num;
	}
	public void run () {
		d.pickUp(num);
		System.out.println ("Philosopher # " + num + " Eating ");
		d.putDown(num);
	}
}

class diningPhilosopher1Monitor extends monitorSU {
	final int n =5; 				// number of philosophers
	final int thinking = 0; final int hungry = 1; final int starving = 2; final int eating = 3;
	int state[] = new int[n]; 		// state[i] indicates the state of philosopher i
	// philosopher i blocks herself on self[i] when she is hungry, but unable to eat
	conditionVariable[] self  = new conditionVariable[n];

	private final int left(int i) { return (n + i - 1) % n; }

	private final int right(int i) { return (i + 1) % n; }
	
	diningPhilosopher1Monitor() {
		for (int i = 0; i < n; i++) state[i] = thinking;
		for (int j = 0; j < n; j++) self[j] = new conditionVariable( );
	}
	public void pickUp(int i) {
		enterMonitor();
		state[i] = hungry;
		test(i);		
		if (state[i] != eating) 
			self[i].waitC();
		exitMonitor();
	}
	public void  putDown(int i) {
		enterMonitor();
		state[i] = thinking;
		test(left(i));
		test(right(i));
		exitMonitor();
	}

	private void test(int k) {
	// if philosopher k is hungry and can eat, change her state and signal her queue.
		if ((state[k] == hungry) && (state[left(k)] != eating)  && 
			(state[right(k)] != eating)) {
			state[k] = eating; 
			self[k].signalC();	// no affect if philosopherk is not waiting on condition variable self[k]
										// which is the case if test() was called from pickUp().
		}													
	}
}
//Listing 4-8 Class diningPhilosopher1.

