#ifndef CONTROL_H
#define CONTROL_H

#include "srEvent.h"
#include "monitorEvent.h"
#include <string>
#include "monitorSpecEvent.h"

class Control { 
public:
	virtual void trace(monitorEvent m) = 0;
/* srEvent& ?? */
	virtual void trace(srEvent& e)  = 0;
	virtual void trace(int ID) = 0;
	virtual void requestEntryPermit(int ID)  = 0;
	virtual void releaseEntryPermit() = 0;
	virtual void requestPermit(int ID) = 0;
	virtual void releasePermit() = 0;
	virtual void requestMPermit(monitorEvent::eventTypes op, int ID, std::string methodName, 
		std::string conditionName)  = 0;
	virtual void releaseMPermit()  = 0;
	virtual void requestMPermitSpecTest(int ID)  = 0;
	virtual void requestAndReleaseCommPermit(int ID, std::string eventName)  = 0;
	virtual void exerciseEvent(int ID, std::string eventName)  = 0;
	virtual void traceCommEvent(monitorSpecEvent m)  = 0;
	//virtual void start()  = 0;
	virtual void requestSendPermit(int ID, std::string channelName, int callerVersionNumber)  = 0;
	virtual bool requestSendPermitX(int ID, std::string channelName, int callerVersionNumber)  = 0;
	virtual bool requestSendPermitMS(int ID, std::string channelName, int callerVersionNumber, int calledID)  = 0;
	virtual void msgReceived()  = 0;
	virtual int requestReceivePermitX(int ID, std::string channelName, int calledVersionNumber)  = 0;
	virtual int requestReceivePermitMS(int ID, int calledID, std::string channelName, int calledVersionNumber)  = 0;
	virtual void msgReceived(int caller, int callerVersionNumber)  = 0;
	virtual void sendArrivedRT(int ID, std::string channelName, int callerVersionNumber)  = 0;
	virtual void monitorEnteredRT(int ID, std::string channelName, int callerVersionNumber)  = 0;
};
#endif