#ifndef CONTROLLER_H
#define CONTROLLER_H

#include <string>
#include "traceMessage.h"
#include "thread.h"

class Controller : public Thread {
public:
	virtual void traceMsg(traceMessage m) = 0;
	virtual void traceSendReceive(traceMessage m) = 0;
	virtual void requestSendPermit(int ID, std::string channelName, int callerVersionNumber) = 0;
	virtual bool requestSendPermitX(int ID, std::string channelName, int callerVersionNumber) = 0;
	virtual void requestReceivePermit(int ID, std::string channelName, int calledVersionNumber) = 0;
	virtual int  requestReceivePermitX(int ID, std::string channelName, int calledVersionNumber) = 0;
	virtual bool requestSelectPermit(int ID) = 0;
	virtual void requestElseDelayPermit(int ID, int calledVersionNumber) = 0;
	virtual void requestSendExceptionPermit(int ID, std::string channelName, int callerVersionNumber, int calledVersionNumber) = 0;
	virtual void requestReceiveExceptionPermit(int ID, std::string channelName, int calledVersionNumber) = 0;
	virtual void requestSynchSendPermit(int ID, std::string channelName, int callerVersionNumber) = 0;
	virtual void msgReceived() = 0;
	virtual void msgReceived(int caller, int callerVersionNumber) = 0;
	virtual void sendArrivedRT(int ID, std::string channelName, int callerVersionNumber) = 0;
	virtual void monitorEnteredRT(int ID, std::string channelName, int callerVersionNumber) = 0;
};
#endif