#ifndef MUTEXIDGENERATOR_H
#define MUTEXIDGENERATOR_H

#pragma warning(disable:4786) 
#include <stddef.h>
#include "criticalsectionlock.h"
#include "win32critical_section.h"
#include "mutexlocker.h"
#include <map>
#include <string>
#include <fstream>
#include <iostream>

class InvalidMutexName { // extends InvalidIDException {
public:
	InvalidMutexName() { }
	InvalidMutexName(std::string msg_): msg(msg_) { } // super(msg);}
private:
  std::string msg; 
};

class MutexIDGenerator {
private:
	std::map<std::string,int> names;
	// when replay or test, use IDs generated during trace (not new IDs).
    static criticalSectionLock instanceLock;
	win32Critical_Section dataLock; 
	std::ofstream outputMutexIDs;

	MutexIDGenerator();

	bool containsName(std::string stringID);
	void putName(std::string name, int num);
	void putUserName(std::string name, int num);
	int getNum(std::string name);
public:
	static MutexIDGenerator& instance();
	std::string getID(std::string stringID);
	std::string getIDFromUserName(std::string userName);
};
#endif
