#ifndef OPENEVENT_H
#define OPENEVENT_H
#include <string>
#include <sstream>

class OpenEventX {
private:
	std::string label; 
	int destinationState;
	
public:
	OpenEventX(std::string label, int destinationState_)
		: destinationState(destinationState_) {
		this->label = label;
		this->destinationState = destinationState;
	}
	OpenEventX(std::string label) : destinationState(-2) {
		this->label = label;
	}
	std::string getLabel() const {return label;}
	int getDestinationState() const {return destinationState;}
	friend std::ostream& operator<<(std::ostream& os, const OpenEventX& e);
	std::string toString() {
		std::ostringstream os;
		os << "(" << label << "," << destinationState << ")";
		return os.str();
	}

};
#endif