#ifndef TIMESTAMP_H
#define TIMESTAMP_H

#include <iostream>
#include <string>
#include "vectorTimeStampJ.h"

class Timestamp {
private:
    // the number of processes
    int dimension;
    // the values in the timestamp
    int* values;
	void copy(const Timestamp& b);
	void free();
public:
    Timestamp(int dimension);
	Timestamp(const Timestamp& b);  // copy constructor
	~Timestamp();   // destructor
	const Timestamp& operator=(const Timestamp& b);
    int getDimension () const;
    int getValue (int index) const;
    void setValue (int index, int value);
    // update methods
    void advance (int pid);
    void advance (Timestamp& stamp);

    bool equalTo (Timestamp& stamp) const;
	Timestamp* deepCopy();
    bool lessThan (Timestamp& ts) const;

	std::string toString() const;
	friend std::ostream& operator<<(std::ostream& os, const Timestamp& t);
};
#endif