
#ifndef CONTROLMONITORSU_H
#define CONTROLMONITORSU_H
#include "binarySemaphore.h"
class controlMonitorSU {
// Control monitor used during replay and tracing
// Uses VP() operation and SU signaling, exactly like SU toolbox
public:
   	controlMonitorSU() : reentryCount(0),	mutex(1,false), reentry(0,false) {}
	void enterMonitor();
	void exitMonitor();
	
protected:
	binarySemaphore mutex;;
	binarySemaphore reentry;
	int reentryCount;
	   
	friend class controlConditionVariable;	
};


class controlConditionVariable {
private:
	binarySemaphore threadQueue;
	int numWaitingThreads;
	controlMonitorSU& m;
public:
	//controlConditionVariable(controlMonitorSU* mon);  
	//void signalC();
	//void signalC_and_exitMonitor();
	//void waitC();
	//bool empty();
	//int length();

	controlConditionVariable::controlConditionVariable(controlMonitorSU* mon)
		: threadQueue(0,false), m(*mon), numWaitingThreads(0) {}


	void controlConditionVariable::signalC() {
		if (numWaitingThreads > 0) {
			++(m.reentryCount);
			m.reentry.VP(&threadQueue);
			--(m.reentryCount);
   		}
	}
	 	 
	void controlConditionVariable::signalC_and_exitMonitor() {
		if (numWaitingThreads > 0) {
			threadQueue.V();
		}
		else if ((m.reentryCount) > 0)
			m.reentry.V();
		else
			m.mutex.V();
	}

	void controlConditionVariable::waitC() {
		numWaitingThreads++;
		if ((m.reentryCount) > 0)
			threadQueue.VP(&(m.reentry));
		else
			threadQueue.VP(&(m.mutex));
		--numWaitingThreads;
	}

	bool controlConditionVariable::empty() {
		return (numWaitingThreads == 0);
	}

	int controlConditionVariable::length() {
		return numWaitingThreads;
	}

};
#endif


