#ifndef DEADLOCKWATCHDOG
#define DEADLOCKWATCHDOG

#pragma warning(disable:4786) 
#include "criticalSectionLock.h"
#include <map>
#include <string>
#include <iostream>
#include "Thread.h"

class deadlockWatchdog : public Thread {
private:
	static criticalSectionLock classLock;
	static criticalSectionLock mutex;
	static deadlockWatchdog* instance;
	bool stopped;
	static std::map<int,std::string> status;
	static int mode;
	static bool detectDeadlock;
public:
	deadlockWatchdog();
	static deadlockWatchdog* startInstance();
	static void changeStatus(int ID, std::string statusMessage);
	static void removeThread(int ID);
	static void notifyDeadlock();
	static void stopWatchdog();
	void* run();
};
#endif
