#include "monitorEvent.h"
#include <iostream>
#include <string>

	std::ostream& operator<<(std::ostream& out, const monitorEvent m) {
		out << "(";
		switch (m.eType) {
		case monitorEvent::ENTRY:	out << "ENTRY,";
					break;
			case monitorEvent::REENTRY: out << "REENTRY,";
					break;
			case monitorEvent::WAIT: out << "WAIT,";
					break;
			case monitorEvent::SIGNAL: out << "SIGNAL,";
					break;
			case monitorEvent::SIGNALALL: out << "SIGNALALL,";
					break;
			case monitorEvent::SIGNALANDEXIT: out << "SIGNALANDEXIT,";
					break;
			case monitorEvent::EXIT: out << "EXIT,";
					break;
		}
		out << m.threadID << "," << m.methodName 
			<< "," << m.conditionName << ")";
		return out;
	}

	std::istream& operator>>(std::istream& in, monitorEvent& m) {
		std::string line;	// e.g., (ENTRY,1,deposit,NA)
		in >> line;

		if (!in) 
			return in;

		int first=0;
		first = line.find("("); 
		line = line.substr(first+1,line.size()); // ENTRY,1,deposit,NA)
		first = line.find(","); 
		std::string type = line.substr(0,first); // ENTRY
		line = line.substr(first+1,line.size()); // 1,deposit,"NA")
		if (type == "ENTRY")
			m.eType = monitorEvent::ENTRY;
		else if (type == "REENTRY")
			m.eType = monitorEvent::REENTRY;
		else if (type == "WAIT")
			m.eType = monitorEvent::WAIT;
		else if (type == "SIGNAL")
			m.eType = monitorEvent::SIGNAL;
		else if (type == "SIGNALALL")
			m.eType = monitorEvent::SIGNALALL;
		else if (type == "SIGNALANDEXIT")
			m.eType = monitorEvent::SIGNALANDEXIT;
		else if (type == "EXIT")
			m.eType = monitorEvent::EXIT;
		first = line.find(","); 
		std::string ID = line.substr(0,first); // 1
		line = line.substr(first+1,line.size()); // deposit,NA);
		m.threadID = atoi(ID.c_str());
		first = line.find(","); 
		m.methodName = line.substr(0,first); // deposit
		line = line.substr(first+1,line.size()); // NA);
		first = line.find(")"); 
		m.conditionName = line.substr(0,first); // NA
		return in;
	}

/*
	string Event::GetTU(void) const {
// returns second process in event
// in event foo_1_2_3_4, TU is 4
  int first=0;
  string temp(event);
  first = temp.find("_"); // string up to and including first underscore-1
  temp = temp.substr(first+1,temp.size()); // 1_2_3_4_(x,y)
  first = temp.find("_"); // string up to and including first underscore-1
  temp = temp.substr(first+1,temp.size()); // 2_3_4_(x,y)
  first = temp.find("_"); // string up to and including first underscore-1
  temp = temp.substr(first+1,temp.size()); // 3_4_(x,y)
  first = temp.find("_"); // string up to and including first underscore-1
  temp = temp.substr(first+1,temp.size()); // 4_(x,y)
  first = temp.find("_"); // string up to and including first underscore-1
  temp = temp.substr(0,first); // 4
  //return temp.c_str();
  return temp;
}
*/

/*
	string Event::GetNC(void) const {
// returns x in (x,y)
// in event foo_1_2_3_4_(x,y), NC process is x
  int first=0;
  string temp(event);
  first = temp.find("("); // string up to and including first underscore-1
  temp = temp.substr(first+1,temp.size()); // x,y)
  first = temp.find(","); // string up to and including first underscore-1
  temp = temp.substr(0,first); // x
  //return temp.c_str();
  return temp;
}
*/