#ifndef MONITOREVENT_H
#define MONITOREVENT_H
#include <string>

class monitorEvent {

public:
	enum eventTypes {ENTRY,EXIT,WAIT,SIGNAL,SIGNALALL,REENTRY,SIGNALANDEXIT,COMM};
	monitorEvent(eventTypes eType_, int threadID_, std::string methodName_, 
		std::string conditionName_) :
	eType(eType_), threadID(threadID_), methodName(methodName_), 
	    conditionName(conditionName_) {}

	monitorEvent() {}

	void setEventType(eventTypes eType_) {
		eType = eType_;
	}

	void setThreadID(int threadID_) {
		threadID = threadID_;
	}

	void setmethodName(std::string monitorName_) {
		methodName = monitorName_;
	}

	void setconditionName(std::string conditionName_) {
		conditionName = conditionName_;
	}

	eventTypes getEventType() {
		return eType;
	}

	int getThreadID() {
		return threadID;
	}

	std::string getMethodName() {
		return methodName;
	}

	std::string getConditionName() {
		return conditionName;
	}

	friend std::ostream& operator<<(std::ostream& out, const monitorEvent m);
	friend std::istream& operator>>(std::istream& in, monitorEvent& m);

	eventTypes eType;
	int threadID;
	std::string methodName;
	std::string conditionName;
};

#endif
