
#pragma warning(disable:4786) 
#include "monitorsc.h"
#include "traceorreplay.h"
#include "threaddata.h"
#include "monitoridgenerator.h"
#include "threadIDGenerator.h"
#include "monitorEvent.h"
#include "monitorSpecEvent.h"
#include "threadData.h"
#include "msgTracingAndReplay.h"




	monitorSC::monitorSC() : mutex(1,false), versionNumber(1), control(NULL) {
		char* env = getenv("MODE");
		if (env!=NULL) {
			if (!(strcmp(env,"TRACE")))
				mode = TRACE;
			else if (!(strcmp(env,"REPLAY")))
				mode = REPLAY;
			else if (!(strcmp(env,"TEST")))
				mode = TEST;
			else if (!(strcmp(env,"SPECTEST")) || !(strcmp(env,"COMMTEST")))
				mode = SPECTEST;
			else if (!(strcmp(env,"RT"))) {
				std::cout << "We are currently updating our C++ RT implementation." << std::endl;
				std::cout << "We will post new files shortly and enable RT." << std::endl;
				exit(1);
			}
			else if (!(strcmp(env,"NONE")))
				mode = NONE;
			else mode = NONE;
		}
		else mode = NONE;

		env = getenv("NUMCONTROLLERS");
		 if (env!=NULL) {
			if (!(strcmp(env,"SINGLE")))
				numControllers = 1;
			else numControllers = 0;
		 }
		 else numControllers = 1;
		 env = getenv("RANDOMDELAY");
		 if (env!=NULL) {	
			if	(!(strcmp(env,"ON")))
				randomDelay = true;
			else
				randomDelay = false;
		 }
		 else randomDelay = false;

		 if (mode) {
			if (mode==RT) {
				ID = generateIDRT();
				monitorName = ThreadIDGenerator::instance().getName(ID);
				initVectorTS();
				OpenEventX e (monitorName,-1);
				openList.push_back(e); // (this.monitorName);
				std::string traceFileName;
				//if (numControllers==0)
				//	traceFileName = monitorName;
				//else
					traceFileName = "channel";  // same as for class channel
					//if (numControllers == 1) 
						control = instanceRT(mode,numControllers,strategy,traceFileName);
					//else {
					//	control = (Control*) new msgTracingAndReplay(mode,numControllers,strategy,traceFileName);
					//	control->start();
					//}
			}
			else {
				monitorName = generateID();
				std::string traceFileName;
				if (numControllers == 0) 
					traceFileName = monitorName;
				else
					traceFileName = "Monitor";
				if (mode == TRACE || mode == REPLAY || mode == TEST || mode == SPECTEST)
					if (numControllers == 1) 
						m = monitorTracingReplayTest::instance(mode,numControllers,traceFileName);
					else
						m = new monitorTracingReplayTest(mode,numControllers,traceFileName);
			}
		 }
	}

	monitorSC::monitorSC(std::string monitorName_) : mutex(1,false), versionNumber(1), control(NULL) { 
		monitorName = monitorName_;
		char* env = getenv("mode");
		if (env!=NULL) {
			if (!(strcmp(env,"TRACE")))
				mode = TRACE;
			else if (!(strcmp(env,"REPLAY")))
				mode = REPLAY;
			else if (!(strcmp(env,"TEST")))
				mode = TEST;
			else if (!(strcmp(env,"SPECTEST")) || !(strcmp(env,"COMMTEST")))
				mode = SPECTEST;
			else if (!(strcmp(env,"RT"))) {
				std::cout << "We are currently updating our C++ RT implementation." << std::endl;
				std::cout << "We will post new files shortly and enable RT." << std::endl;
				exit(1);
			}
			else if (!(strcmp(env,"NONE")))
				mode = NONE;
			else mode = NONE;
		}
		else mode = NONE;
		env = getenv("NUMCONTROLLERS");
		if (env!=NULL) {
			if (!(strcmp(env,"SINGLE")))
				numControllers = 1;
			else numControllers = 0;
		}
		else numControllers = 1;
		env = getenv("RANDOMDELAY");
		if (env!=NULL) {	
			if	(!(strcmp(env,"ON")))
				randomDelay = true;
			else
				randomDelay = false;
		 }
		 else randomDelay = false;

		 if (mode) {
			if (mode==RT) {
				ID = generateIDRT();
				monitorName = ThreadIDGenerator::instance().getName(ID);
				initVectorTS();
				OpenEventX e (monitorName,-1);
				openList.push_back(e); // (this.monitorName);
				std::string traceFileName;
				//if (numControllers==0)
				//	traceFileName = monitorName;
				//else
					traceFileName = "channel";  // same as for class channel
					//if (numControllers == 1) 
						control = instanceRT(mode,numControllers,strategy,traceFileName);
					//else {
					//	control = (Control*) new msgTracingAndReplay(mode,numControllers,strategy,traceFileName);
					//	control->start();
					//}
			}
			else {
				std::string traceFileName = generateIDFromUserName(monitorName);
				if (numControllers==1) // single mler
					traceFileName = "Monitor";
				if (mode == TRACE || mode == REPLAY || mode == TEST || mode == SPECTEST) {
					if (numControllers == 1) { // single controller
						m = monitorTracingReplayTest::instance(mode,numControllers,traceFileName);
					}
					else {
						m = new monitorTracingReplayTest(mode,numControllers,traceFileName);
					}
				}
			}
		 }
	}


	monitorSC::~monitorSC() { 
		if (mode && numControllers==0) {
			if (mode == TRACE || mode == REPLAY || mode == TEST || mode == SPECTEST) 
				delete m;
			// RT always has a single controller (numControllers==1)
			//else if (mode == RT)
			//	delete control;
		}
	}

	int monitorSC::generateIDFromUserNameRT(std::string userName) {
		return (ThreadIDGenerator::instance().getIDFromUserName(userName));
	}

	int monitorSC::generateIDRT() {
		std::string stringID;
		data d = threadData::instance().getThreadData(GetCurrentThreadId()); // return child thread or main
		//if (d.threadID != -1) 
			stringID = d.threadName;
		//else
		//	stringID = "";

		const std::string thisClassName = "monitorSC";

		//unsigned int position = stringID.find("_"); 
		//if (position > -1 && position < stringID.length())
			stringID = stringID + "_" + thisClassName;
		//else
		//	stringID = "main_" + thisClassName;
		
		int myID = ThreadIDGenerator::instance().getID(stringID);
		return myID;
	}

	std::string monitorSC::generateID() {
		const std::string thisClassName = "monitor";
		std::string threadName;
		//thisClassName = typeid(*this).name(); // will return "Thread"
		data d = threadData::instance().getThreadData(GetCurrentThreadId());	
		//if (d.threadID != -1) 
		  threadName = d.threadName;
		//else
		//  threadName = "";
		//int position = threadName.find("_"); 
		//if (position > -1 && (size_t) position < threadName.length())
		  threadName = threadName + "_" + thisClassName;
		//else
		//  threadName = "main_" + thisClassName;
			
		std::string myID = MonitorIDGenerator::instance().getID(threadName);
		return myID;
	}

	std::string monitorSC::generateIDFromUserName(std::string userName) {
	//	System.out.println("User Name: " + userName);
		return (MonitorIDGenerator::instance().getIDFromUserName(userName));
	}

	monitorSC::monitorSC(int mode): mutex(1,false) {
	// This constructor is called from monitorTraceAndReplay so no mler/replay/trace is used
		mode=NONE;
	}

  	Control* monitorSC::instanceRT(int mode, 
		int numControllers,	int strategy, std::string traceFileName) { 
			//System.out.println("get controller");
			return msgTracingAndReplay::getInstance(mode,numControllers,strategy,traceFileName);
	}
	   // Returns the integer clock value associated with this monitor.
	int monitorSC::getIntegerTS() { 
		return vectorTS.getIntegerTS(getID());
	}
    
	// Increments the integer clock associated with this monitor.
    void monitorSC::updateIntegerTS() { 
		//System.out.println("MonitorSC: updating integer timestamp for " + getID());
		vectorTS.updateIntegerTS(getID());
    } 

	// Updates the integer clock with the value passed in.
	void monitorSC::setIntegerTS(int ts){
		vectorTS.setIntegerTS(getID(),ts);
	}

   /*
    * Merges integer clock with the given clock.
    * Sets the integer clock to the larger of two clock values, 
   */
	void monitorSC::mergeIntegerTS(int ts){
		int clockValue = vectorTS.getIntegerTS(getID());
		setIntegerTS(clockValue>ts+1?clockValue:ts+1);
	}

	// Returns a clone of the vector timestamp associated with this thread
	vectorTimeStamp& monitorSC::getVectorTS() { 
		return vectorTS; // vectorTS.clone(); 
	} 
    
	// Updates vector timestamp with the passed in vector timestamp
	void monitorSC::updateVectorTS(const vectorTimeStamp& newTS) { 
		vectorTS.updateVectorTS(newTS);
	} 

	void monitorSC::initVectorTS() {
		vectorTS.init(getID());
	}

	void monitorSC::enterMonitor(std::string methodName) {

		int ID=0;      int callerForReceiveEvent = -1;
		if (mode == TRACE || mode == REPLAY || mode == TEST || mode == SPECTEST || mode == RT) {
			ID = (threadData::instance().getThreadData(GetCurrentThreadId())).threadID;
		}
		if (mode == REPLAY) {
			requestEntryPermit(ID);
		}
		else if (mode == TEST) {
			requestMPermit(monitorEvent::ENTRY, ID, monitorName + "::" + methodName,"NA");
		}
		else if (randomDelay && mode == TRACE) {
			Sleep(rand()%delayAmount);	// default delayAmount is 750
		}
		else if (mode == SPECTEST) {
			requestMPermitSpecTest(ID); 
   		}
   		else if (mode == RT) {
			threadData::instance().getThreadData(GetCurrentThreadId()).vectorTS.updateIntegerTS(ID);
			control->requestSendPermitMS(ID,monitorName + ":" + methodName,threadData::instance().getThreadData(GetCurrentThreadId()).getVersionNumber(),getID());
         	

			srEvent e(ID,getID(),threadData::instance().getThreadData(GetCurrentThreadId()).getAndIncVersionNumber(),
							getVersionNumber(),monitorName + ":" + methodName,-1,
							srEvent::UNACCEPTED_ASYNCH_SEND, threadData::instance().getThreadData(GetCurrentThreadId()).vectorTS.getVectorTS(),"unaccepted_send_entry", false,openList,srEvent::MONITOR_CALL);
     		control->trace(e); 
     		
			control->msgReceived();
				
			callerForReceiveEvent = control->requestReceivePermitMS(ID,getID(),monitorName + ":" + methodName,getVersionNumber());  		

			//System.out.println(ID+" got receivePermitX");
	   }
		mutex.P();

		if (mode == REPLAY) {
		  releaseEntryPermit();
		}
		else if (mode == TEST) {
			currentMethodName = monitorName + "::" + methodName;
			releaseMPermit();
		}
		else if (mode == TRACE) {
			//std::cout << "get monitorName+methodName" << std::endl;
			currentMethodName = monitorName + "::" + methodName;
			//std::cout << "got monitorName+methodName" << std::endl;
     		trace(monitorEvent::ENTRY,ID,currentMethodName,"NA");
		}
		else if (mode == SPECTEST) {
		
		}
   		else if (mode == RT) {
   			currentMethodName = monitorName + ":" + methodName;
   			
  			if (callerForReceiveEvent==-2) {
   				control->monitorEnteredRT(ID, currentMethodName,threadData::instance().getThreadData(GetCurrentThreadId()).getVersionNumber());
   			}			
			updateIntegerTS();
				
			srEvent e(-2,getID(),-2,getVersionNumber(),
				monitorName + ":" + methodName,-1,srEvent::UNACCEPTED_RECEIVE,
				getVectorTS(),"unacceptedReceive",false,openList,srEvent::UNACCEPTED_RECEIVE); 
         		
        	//System.out.println(ID+"entered");
         		
   			control->trace(e);
   	      
		    // update receiver with callers timestamp: send ----> receive
   			updateVectorTS((threadData::instance().getThreadData(GetCurrentThreadId())).vectorTS);
	  		srEvent f(ID,getID(),threadData::instance().getThreadData(GetCurrentThreadId()).getVersionNumber()-1,
							getAndIncVersionNumber(),monitorName + ":" + methodName,-1,
							srEvent::ASYNCH_RECEIVE, getVectorTS(),"", true,openList,srEvent::MONITOR_ENTRY);
     		control->trace(f);

			// report caller and caller version number
			control->msgReceived(ID,threadData::instance().getThreadData(GetCurrentThreadId()).getVersionNumber()-1);

			(threadData::instance().getThreadData(GetCurrentThreadId())).vectorTS.updateVectorTS(getVectorTS());

		}
	}

	void monitorSC::enterMonitor() {
		mutex.P();
		if (mode != NONE) {
			std::cout << "Error: In trace, test, replay, spectest, or rt mode, the call to " << std::endl;
			std::cout << "enterMonitor() must include the name of the method being entered, e.g., " << std::endl;
			std::cout << "   enterMonitor(\"deposit\");" << std::endl;
			exit(1);
		}
	}

	void monitorSC::exitMonitor() {
		int ID=0;
		if (mode == TRACE || mode == REPLAY || mode == TEST) {
			ID = (threadData::instance().getThreadData(GetCurrentThreadId())).threadID;
		}
		if (mode == TRACE) {
     		trace(monitorEvent::EXIT,ID,currentMethodName,"NA"); 
		}
		else if (mode == TEST) {
			requestMPermit(monitorEvent::EXIT,ID,currentMethodName,"NA");			
   		}
 		else if (mode == RT) {
			// update monitor timestamp on exit in case send/receive done inside monitor
   			updateVectorTS((threadData::instance().getThreadData(GetCurrentThreadId())).vectorTS);
	   }
		mutex.V();
	}
	
	void monitorSC::exerciseEvent(std::string eventName) {
		int ID=0;
		if (mode == TRACE || mode == SPECTEST) {
					ID = (threadData::instance().getThreadData(GetCurrentThreadId())).threadID;
		}
		if (mode == TRACE) {
     		traceCommEvent(ID,eventName); 
		}
		else if (mode == SPECTEST) {
			m->exerciseEvent(ID,eventName); // control execution of event
   		}	
	}
	
	void monitorSC::traceCommEvent(int ID, std::string eventName) {
		monitorSpecEvent e(ID,eventName);
			m->traceCommEvent(e); // output event
	}

	void monitorSC::requestMPermit(monitorEvent::eventTypes op, int ID, std::string methodName, 
		                         std::string conditionName) {
		m->requestMPermit(op,ID,methodName,conditionName);
	}
	
	void monitorSC::releaseMPermit() {
 		m->releaseMPermit();
	}

	void monitorSC::requestEntryPermit(int ID) {
		m->requestEntryPermit(ID);
	}
	void monitorSC::releaseEntryPermit() {
		m->releaseEntryPermit();
	}
	
	void monitorSC::trace(monitorEvent::eventTypes op, int ID, std::string methodName, 
		                         std::string conditionName){
		monitorEvent me(op,ID,methodName,conditionName);
		m->trace(me);
	}
	
	void monitorSC::requestMPermitSpecTest(int ID) {
		m->requestMPermitSpecTest(ID);
    }


