
#ifndef MONITORTRACINGREPLAYTEST_H
#define MONITORTRACINGREPLAYTEST_H
#include "controlmonitorsu.h"
#include <vector>
//#include "controlconditionvariable.h"
#include "criticalsectionlock.h"
#include "monitorevent.h"
#include "monitorspecevent.h"
#include <iostream>
#include <fstream>
#include <string>
#include <windows.h>

class monitorTracingReplayTest : public controlMonitorSU {
// Used to trace and replay monitors.
// Class controlMonitor is an SU toolbox

public:
	friend DWORD WINAPI monTestWatchDog(LPVOID pVoid);
	friend DWORD WINAPI monSpecTestWatchDog(LPVOID pVoid);
	monitorTracingReplayTest(int mode, int numControllers,	std::string traceFileName);
	~monitorTracingReplayTest();
	void requestMPermit(monitorEvent::eventTypes op, int ID, std::string methodName, 
		                         std::string conditionName);
	void releaseMPermit();
	void requestMPermitSpecTest(int ID);
	void requestAndReleaseCommPermit(int ID, std::string eventName);
	void requestEntryPermit(int ID);
	void releaseEntryPermit();
	void trace(monitorEvent m);
	void traceCommEvent(monitorSpecEvent m);
	void exerciseEvent(int ID, std::string eventName);
	
	static monitorTracingReplayTest* instance(int mode, 
			int numControllers, std::string traceFileName);
private:
	std::vector<int> SMsequence;
	std::vector<monitorEvent> Msequence;
	std::vector<monitorSpecEvent> COMMsequence;
	controlConditionVariable** threads;  // all semaphores initialized to 0
	int index;
	int numberOfThreads;
	std::ifstream inputReplayText;
	std::ifstream inputTestText;
	std::ifstream inputSpecTestText;
	std::ofstream outputReplayText;	
	std::ofstream outputTestText;
	std::ofstream outputSpecTestText;
	int mode;
	int numControllers;
	std::string traceFileName;
	HANDLE hTestThread;
	HANDLE hSpecTestThread;
	DWORD winThreadID;
	void exitProgram() {exit(1);}
	static criticalSectionLock instanceLock;
};
#endif


