#ifndef MSGTRACINGANDREPLAY_H
#define MSGTRACINGANDREPLAY_H

#include "srEvent.h"
#include "traceMessage.h"
#include "monitorEvent.h"
#include <string>
#include <iostream>
#include "monitorSpecEvent.h"
#include "Control.h"
#include "Controller.h"
#include "requestPermitMessage.h"
#include "msgReceivedMessage.h"
#include "criticalSectionLock.h"
#include "unacceptedSREvent.h"
#include <map>
#include <set>

#include "selectableEntryC.h"

class msgTracingAndReplay : Controller, Control {
public:
	msgTracingAndReplay(int mode, int numControllers, int strategy, std::string traceFileName);
	static Control* getInstance(int mode, int numControllers, int strategy, std::string traceFileName);
	virtual void trace(monitorEvent m) {}
	virtual void trace(srEvent& e);
	virtual void trace(int ID) {}
	virtual void requestEntryPermit(int ID) {}
	virtual void releaseEntryPermit() {}
	virtual void requestPermit(int ID) {}
	virtual void releasePermit() {}
	virtual void requestMPermit(monitorEvent::eventTypes op, int ID, std::string methodName, std::string conditionName) {}
	virtual void releaseMPermit() {}
	virtual void requestMPermitSpecTest(int ID) {}
	virtual void requestAndReleaseCommPermit(int ID, std::string eventName) {}
	virtual void exerciseEvent(int ID, std::string eventName){}
	virtual void traceCommEvent(monitorSpecEvent m) {}
	//virtual void start() {}
	virtual void requestSendPermit(int ID, std::string channelName, int callerVersionNumber) {}
	virtual bool requestSendPermitX(int ID, std::string channelName, int callerVersionNumber) {return false;}
	virtual bool requestSendPermitMS(int ID, std::string channelName, int callerVersionNumber, int calledID);
	virtual void msgReceived();
	virtual int requestReceivePermitX(int ID, std::string channelName, int calledVersionNumber) {return 0;}
	virtual int requestReceivePermitMS(int ID, int calledID, std::string channelName, int calledVersionNumber);
	virtual void msgReceived(int caller, int callerVersionNumber);
	virtual void sendArrivedRT(int ID, std::string channelName, int callerVersionNumber) {}
	virtual void monitorEnteredRT(int ID, std::string channelName, int callerVersionNumber);
	virtual void traceMsg(traceMessage m) {}
	virtual void traceSendReceive(traceMessage m) {}
	virtual void requestReceivePermit(int ID, std::string channelName, int calledVersionNumber) {}
	virtual bool requestSelectPermit(int ID) {return false;}
	virtual void requestElseDelayPermit(int ID, int calledVersionNumber) {}
	virtual void requestSendExceptionPermit(int ID, std::string channelName, int callerVersionNumber, int calledVersionNumber) {}
	virtual void requestReceiveExceptionPermit(int ID, std::string channelName, int calledVersionNumber) {}
	virtual void requestSynchSendPermit(int ID, std::string channelName, int callerVersionNumber) {}
	virtual bool appCompleted();

	void resetController();

	void* run ();
private:
	static msgTracingAndReplay* instance;
	static criticalSectionLock instanceLock;
};
#endif