// The definition of entry assumes that there can be many clients but only one server
#ifndef SELECTABLEENTRYC_H
#define SELECTABLEENTRYC_H

#include "synchChannelC.h"
#include "selectableSynchChannelC.h"
#include "selectable.h"
#include "messageptr.h"
#include <string>


template <class T>
class selectableEntryC : public selectableSynchChannelC<T> {
private:
	callMsg<T>* cm; 
public:
	selectableEntryC() : cm(NULL) {}
	template <class T>
	message_ptr<T> call(message_ptr<T> request) {
		synchChannelC<T>* replyChannel = new synchChannelC<T>();
		callMsg<T>* cMsg = new callMsg<T>(request,replyChannel);
		send(cMsg);
		return replyChannel->receive();
	}

 	message_ptr<T> call() {
		synchChannelC<T>* replyChannel = new synchChannelC<T>();
		callMsg<T>* cMsg = new callMsg<T>(replyChannel);
		send(cMsg);
		return replyChannel->receive();
	}

	//message_ptr<T> accept();
	//void reply(message_ptr<T> response);
	//void reply();
	//message_ptr<T> acceptAndReply();
	//std::string getChannelName();
	
	message_ptr<T> accept() { 
		cm = receive(); 
		return cm->request;
	}

	message_ptr<T> acceptAndReply() { 
		cm = receive(); cm->replyChannel->send(); 
		return cm->request;
	}

	std::string getChannelName() {return "foo";}

	void reply() { 
		cm->replyChannel->send(); 
	}

	void reply(message_ptr<T> response) { 
		cm->replyChannel->send(response); 
	}
};

#endif