
#include "selectiveWaitC.h"
#include "selectException.h"
#include "selectable.h"
#include <string>
#include <vector>

	//template<class T>
	//void selectiveWaitC::add(selectable<T>& s) {
	//void selectiveWaitC::add(selectable<item>& s) {
	void selectiveWaitC::add(selectable& s) {
		list.push_back(&s);s.setSelect(this);
		//listB.push_back(&s);

	}
	void selectiveWaitC::add(delayAlternative& d) {
		delay = &d;
        if (hasDelay) {
			std::cout << "Warning: A selectiveWait cannot have more than one delay alternative." << std::endl;
			std::cout << "Warning: Only one of the delay alternatives can be selected." << std::endl;
		 }
 		 hasDelay = true;
		 if (hasElse) {
			 std::cout << "Warning: A selectiveWait cannot have an else alternative and a delay alternative." << std::endl;
			 std::cout << "Warning: Only one of the else/delay alternatives can be selected." << std::endl;
		 }
    }

    void selectiveWaitC::add(elseAlternative& e) {
		else_ = &e;
       
		if (hasElse) {
			std::cout << "Warning: A selectiveWait cannot have more than one else alternative." << std::endl;
			std::cout << "Warning: Only one of the else alternatives can be selected." << std::endl;
		}
		hasElse = true;
		if (hasDelay) {
			std::cout << "Warning: A selectiveWait cannot have a delay alternative and an else alternative." << std::endl;
			std::cout << "Warning: Only one of the else/delay alternatives can be selected." << std::endl;
		}
    }

    void selectiveWaitC::removeElse() {
		hasElse = false;
		else_ = NULL;
    }

    void selectiveWaitC::removeDelay() {
		hasDelay = false;
		delay = NULL;
    }

    void selectiveWaitC::clearAll() {

        for (size_t i=0; i<list.size(); i++) {
           list[i]->clearOpen();
        }

    }

    void selectiveWaitC::openAll() {

        for (size_t i=0; i<list.size(); i++) {
            //selectable<item>* s = list[i];
			selectable* s = list[i];
            if (s->testGuard()) s->setOpen();
        }

    }

    int selectiveWaitC::testAll() {

		int oldest = 999999; // use max_int
		int i = 0;
		//int j = 1;
		bool AtLeastOneTrueGuard = false;
		for (size_t j=0; j<list.size(); j++) {
       		//selectable<item>* s = list[j];
			selectable* s = list[j];
      		AtLeastOneTrueGuard = AtLeastOneTrueGuard || s->testGuard();
          	if (s->testReady() && s->testGuard()) {
				int oldestSArrival = s->getOldestArrival();
				if (oldestSArrival < oldest) {
					i = j+1;
					oldest = oldestSArrival;
// Optimization for RT? no need to find earliest 
					break;
				}
			}
        }
        if (i == 0 && !AtLeastOneTrueGuard)
          return -1; // all guards are false
        else 
          return i;

    }

	int selectiveWaitC::choose() {

		mutex.P();
		int readyIndex = 0;
		readyIndex=testAll();
		if (readyIndex<=0) { // not ready
			if (hasElse) {
				mutex.V();
				return list.size()+1;
			}
        	openAll();
			if (hasDelay && delay->testGuard()) { // allow timeout
   	     		long waitTime = delay->getMsecDelay();
				waiting= true;
				mutex.V();
        		arrival.P(waitTime);
				mutex.P();
				waiting =false;
				readyIndex=testAll();
        		if (readyIndex <= 0)  {
					//RHC: must be timeout here, since no unrelated notifications. 
              		readyIndex = list.size()+1;
				}
			} // allow timeout
			else { // no else or open delay
				if (readyIndex == -1) {           // all accept alternatives have false guards
					mutex.V();
					throw new selectException();  // && the delay alternative is closed or no else
				}
				waiting = true;
				mutex.V();
				arrival.P();
				mutex.P();
				waiting = false;
				readyIndex=testAll();
			} // no else or delay
		} // not ready
		clearAll();
		mutex.V();
		return readyIndex;

	} // choose
	
	
	std::string selectiveWaitC::getChannelName() {return "foo";}

    void selectiveWaitC::resetOpenList() {}

	std::vector<int>* selectiveWaitC::getOpenList() {
		std::vector<int>* v = new std::vector<int>;
		return v;
	}

	void selectiveWaitC::notify() {if (waiting) arrival.V();}
	void selectiveWaitC::lock() {mutex.P();}
	void selectiveWaitC::unlock(){mutex.V();}
