// contains classes monitorDebuggingToolbox and monitorTracingAndReplay
#ifndef SEMAPHOREANDLOCKTRACINGANDREPLAY_H
#define SEMAPHOREANDLOCKTRACINGANDREPLAY_H

#pragma warning(disable:4786) 
#include "win32Semaphore.h"
#include "traceOrReplay.h"
#include "criticalSectionLock.h"
#include <fstream>
#include <string>
#include <vector>

class semaphoreAndLockTracingAndReplay {
// Provides Trace and Replay for semaphores or locks. SYNseq is a simple 
// PV-sequence or LockUnlock-sequence. Trace or Replay is selected by the user.
private:
	int index;
	int numberOfThreads; // max number of threads
	win32Semaphore** threads;
	bool* hasRequested;

	std::vector<int> SYNsequence;
	std::ifstream infile;
	std::ofstream outfile;

	static criticalSectionLock instanceLock;

	int mode;
	int numControllers;
	std::string traceFileName;

	win32Semaphore* mutex;
public:
	semaphoreAndLockTracingAndReplay(int mode_, int numControllers_, 
		std::string traceFileName_);
	~semaphoreAndLockTracingAndReplay();
	static semaphoreAndLockTracingAndReplay* instance(int mode, 
			int numControllers, std::string traceFileName);
	void trace(int ID); 
	void requestPermit(int ID); 
	void releasePermit();
};

#endif
