#include "srEvent.h"
#include <vector>


void srEvent::copy(const srEvent& b) {
	caller = b.caller;
	called = b.called;
	callerVersionNumber = b.callerVersionNumber;
	calledVersionNumber = b.calledVersionNumber;
	channelName = b.channelName;
	channelVersionNumber = b.channelVersionNumber;
	eType = b.eType;
	vectorTS.reset(b.vectorTS.get()->clone());
	label = b.label;
	isEntry = b.isEntry;
	openList = b.openList;
    eType2 = b.eType2;
    isRecollected = b.isRecollected;
}
void srEvent::free() {}

const srEvent& srEvent::operator=(const srEvent& b) {
  if (this != &b) {
    free();
    copy(b);
  }
  return *this;
}
std::ostream& operator<<(std::ostream& os, const srEvent& e) {
   std::string openListString;
   bool first = true;
   openListString.append("[");
   std::vector<OpenEventX> openList = e.getOpenList();
   if (e.openList.size()>0) {
   	for (size_t i=0; i<openList.size(); i++) {
   	  if (!first) {
   	    openListString.append(",");
   	  }
   	  else 
   	    first = false;
  	  openListString.append(openList[i].toString());
   	}
   }
   openListString.append("]");
   if (e.label == "") 
	   os << "(" <<	e.caller << "," << e.called << "," << e.callerVersionNumber
		  << "," << e.calledVersionNumber << "," + e.channelName
		  << "," << e.channelVersionNumber << "," << e.eType << "," << e.isEntry  
		  << "," << openListString << "," << e.eType2 << "," << e.isRecollected << ")" << *(e.vectorTS);
	else 
		os << "(" << e.caller << "," << e.called << "," << e.callerVersionNumber
		   << "," << e.calledVersionNumber << "," << e.channelName
		   << "," << e.channelVersionNumber << "," << e.eType << "," << e.isEntry << "," << e.label 
		   << "," << openListString << "," << e.eType2 << "," << e.isRecollected << ")" << *(e.vectorTS);	
	
		return os;
}

bool operator ==(const srEvent& left, const srEvent& right) {
	return left.caller == right.caller && left.called == right.called
		&& left.callerVersionNumber == right.callerVersionNumber
		&& left.calledVersionNumber == right.calledVersionNumber
		&& left.channelName == right.channelName 
		&& left.channelVersionNumber == right.channelVersionNumber
		&& left.eType == right.eType;
} 

/*
Note: Not sure what to do with this. C++ has a similar functor? or something
      Will == suffice?	
//int compareTo(Object o2) 
bool operator<<(const srEvent& left, const srEvent& right) {
		if (left.channelVersionNumber < right.channelVersionNumber)
			return -1; 
		else if (left.caller == right.caller && left.called == right.called
				&& left.callerVersionNumber == right.callerVersionNumber
				&& left.calledVersionNumber == right.calledVersionNumber
				&& left.channelName == right.channelName;
				&& left.channelVersionNumber == right.channelVersionNumber
				&& left.eType == right.eType) {
			return 0;
		}
		else
			return 1;
	} 



*/
