#include "srThreadEvent.h"

void srThreadEvent::copy(const srThreadEvent& b) {
	thisThread = b.thisThread;
	thisThreadVersionNumber = b.thisThreadVersionNumber;
	otherThread = b.otherThread;
	otherThreadVersionNumber = b.otherThreadVersionNumber;
	channelName = b.channelName;
	channelVersionNumber = b.channelVersionNumber;
	eType = b.eType;
	vectorTS.reset(b.vectorTS.get()->clone());
}
void srThreadEvent::free() {}

const srThreadEvent& srThreadEvent::operator=(const srThreadEvent& b) {
  if (this != &b) {
    free();
    copy(b);
  }
  return *this;
}
	
bool operator ==(const srThreadEvent& left, const srThreadEvent& right) {
	return left.thisThread == right.thisThread && left.otherThread == right.otherThread
		&& left.thisThreadVersionNumber == right.thisThreadVersionNumber
		&& left.otherThreadVersionNumber == right.otherThreadVersionNumber
		&& left.channelName == right.channelName
		&& left.channelVersionNumber == right.channelVersionNumber
		&& left.eType == right.eType;
} 


std::ostream& operator<<(std::ostream& os, const srThreadEvent& e) {
   os << "(" << e.thisThread << "," << e.thisThreadVersionNumber << "," << e.otherThread 
	   << "," << e.otherThreadVersionNumber << "," << e.channelName 
	   << "," << e.channelVersionNumber << "," << e.eType << ")" << *(e.vectorTS);
   return os;
}

	/*
  // Like srEvent, what to do with this?
  	int compareTo(Object o2) {
		srThreadEvent that = (srThreadEvent) o2;
		if (this.thisThreadVersionNumber < that.thisThreadVersionNumber)
			return -1;
//		else if (this.equals(that)) // (this.thisThreadVersionNumber == that.thisThreadVersionNumber)
		else if (thisThread == that.thisThread && otherThread == that.otherThread
				&& thisThreadVersionNumber == that.thisThreadVersionNumber
				&& otherThreadVersionNumber == that.otherThreadVersionNumber
				&& channelName.equals(that.channelName) 
				&& channelVersionNumber == that.channelVersionNumber
				&& eType.equals(that.eType))
			return 0;
		else
			return 1;
	}


	*/	