#ifndef SYNCHCHANNELC_H
#define SYNCHCHANNELC_H

#include "channel.h"
#include "win32semaphore.h"
#include "mutexLock.h"
//#include "message.h"
#include "messageptr.h"
#include "nullMessageException.h"


template <class T>
class synchChannelC  : public channel<T> {
public:
	synchChannelC() : sent(0), received(0), msg(0) {}
	//template <class T2>
		//void send(message_ptr<T2> sentMsg) 
		void send(message_ptr<T> sentMsg) {
		    if (sentMsg.get() == NULL) {
				throw new NullMessageException("Null message passed to send()");
			}
			mutexSending.lock();
			msg = sentMsg;
			sent.V(); 
			received.P(); 
			mutexSending.unlock();
	}
	//template <class T2>
	message_ptr<T> receive() {
		mutexReceiving.lock();
		sent.P();
		message_ptr<T> receivedMessage = msg; // msg's dumb pointer set to null;
		received.V();
		mutexReceiving.unlock();
		return receivedMessage;
	}
	void send() {
	// send a null message; msg's dumb pointer is constructed as null, 
	// and it's null after every receive() so use msg as it is
		mutexSending.lock();
		sent.V();
		received.P();
		mutexSending.unlock();
	}
private:
	//template <class T>
	message_ptr<T> msg;
	mutexLock mutexSending;
	mutexLock mutexReceiving;
	win32Semaphore sent;
	win32Semaphore received;
};

#endif
