#pragma warning(disable:4786) 
#include "threaddata.h"
#include <stddef.h>
#include "criticalsectionlock.h"
#include <assert.h>
#include <iostream>

criticalSectionLock threadData::instanceLock;

threadData& threadData::instance(){
	mutexLocker<criticalSectionLock> mutex(instanceLock); 
	/*
  	if (!alreadyCreated) {  // already created should be volatile
	    instance_ = new threadData;
		  alreadyCreated = true;
		}
	*/
	static threadData instance;
	 //return instance_;
	return instance;
  }

data& threadData::getThreadData(unsigned long winThreadID) {
	mutexLocker<win32Critical_Section> mutex(dataLock);
	std::map<unsigned long, data>::iterator pos;
	//data dataOfCurrentThread; // (0,"");
	pos = mapID.find(winThreadID);
	if (pos != mapID.end())
	  //std::cout << "getThreadID found " << pos->second.threadID << " for " << winThreadID << std::endl;
	  //dataOfCurrentThread = pos->second;
		return  pos->second;
	//}
	//else
		//std::cout << "getThreadID not found threadID for " << winThreadID << std::endl;
	else
		return mainData;
	//return dataOfCurrentThread;
	// returns threadId of 0 if data is not found; The main
	// thread is the only thread whose daata can be missing.
}

void threadData::addThreadData(unsigned long winThreadID, data d) {
  mutexLocker<win32Critical_Section> mutex(dataLock);
  //std::cout << "threadID adding " << d.threadID << " for " << winThreadID << std::endl;
  // p.second is true if insert success and false if already in map
  std::pair<std::map<unsigned long, data>::iterator,bool> p = 
	  mapID.insert(std::make_pair(winThreadID,d));
  if (!p.second) // system reuses thread IDs so be prepared to reuse winThreadID
		p.first->second = d;
  //assert(p.second); 
}

void threadData::removeThreadData(unsigned long winThreadID) {
  mutexLocker<win32Critical_Section> mutex(dataLock);
  int num = mapID.erase(winThreadID);
	assert(num==1); // data must be present
}
