#ifndef THREADDATA_H
#define THREADDATA_H

#pragma warning(disable:4786) 

#include <stddef.h>
#include "criticalsectionlock.h"
#include "win32critical_section.h"
#include "mutexlocker.h"
#include <map>
#include <string>
#include "vectorTimeStamp.h"



struct data {
	int threadID;
	std::string threadName;
	int versionNumber;
	vectorTimeStamp vectorTS;
	data (int ID, std::string name)
	 : threadID(ID), threadName(name), versionNumber(1), vectorTS(ID) {}
	 //data() : threadID(), threadName() {}
	 int getAndIncVersionNumber() {return versionNumber++;}
	 int getVersionNumber() {return versionNumber;}
};

class threadData {
public:
	static threadData& instance();
	void addThreadData(unsigned long winThreadID, data d);
	void removeThreadData(unsigned long winThreadID);
	data& getThreadData(unsigned long winThreadID);
private:
	static criticalSectionLock instanceLock;
	threadData(): mainData(0,"main"){} 
	win32Critical_Section dataLock;
	// mapID maps winThreadIDs to thread data (threadId + threadName)
	std::map<unsigned long,data> mapID;
	data mainData; // data for main thread
};
#endif
