
import java.util.*;


/*********************Select*****************************/
// implements choice
public final class selectiveWait implements IselectiveWait{
   Vector list = new Vector();
	delayAlternative delay = null;
	elseAlternative else_ = null;
	boolean hasElse = false;
	boolean hasDelay = false;


	public final class delayAlternative {
		private long msecDelay = 0;
		boolean guard = true;

		delayAlternative(long msecDelay) {
			this.msecDelay = msecDelay;
		}

		public long getMsecDelay() {
			return msecDelay;
		}

    	public void guard(boolean g) {
        guard = g;
    	}

    	boolean testGuard(){
        return guard;
    	}

		public void accept() { }
	}

	public final class elseAlternative {
				public void accept() { }
	}

    public void add(selectable s) {
        list.addElement(s);
        s.setSelect(this);
    }

    public void add(delayAlternative d) {
       this.delay = d;
       
		 if (this.hasDelay) {
		 	System.out.println("Warning: A selectiveWait cannot have more than one delay alternative.");
		 	System.out.println("Warning: Only one of the delay alternatives can be selected.");
		 }
		 
		 this.hasDelay = true;
		 
		 if (this.hasElse) {
		 	System.out.println("Warning: A selectiveWait cannot have an else alternative and a delay alternative.");
		 	System.out.println("Warning: Only one of the else/delay alternatives can be selected.");
		 }
    }

    public void add(elseAlternative e) {
       this.else_ = e;
       
		 if (this.hasElse) {
		 	System.out.println("Warning: A selectiveWait cannot have more than one else alternative.");
		 	System.out.println("Warning: Only one of the else alternatives can be selected.");
		 }
		 this.hasElse = true;
		 
		 if (this.hasDelay) {
		 	System.out.println("Warning: A selectiveWait cannot have a delay alternative and an else alternative.");
		 	System.out.println("Warning: Only one of the else/delay alternatives can be selected.");
		 }
    }

    public void removeElse() {
			hasElse = false;
			else_ = null;
    }

    public void removeDelay() {
			hasDelay = false;
			delay = null;
    }

    private void clearAll() {
        for (Enumeration e = list.elements(); e.hasMoreElements();){
           ((selectable)e.nextElement()).clearOpen();
        }
    }

    private void openAll() {
        for (Enumeration e = list.elements(); e.hasMoreElements();){
            selectable s = (selectable)e.nextElement();
            if (s.testGuard()) s.setOpen();
        }
    }

    private int testAll() {
			int oldest = Integer.MAX_VALUE;
			int i = 0;
			int j = 1;
			boolean AtLeastOneTrueGuard = false;
			for (Enumeration e = list.elements(); e.hasMoreElements(); ++j) {
        		selectable s = (selectable)e.nextElement();
       		AtLeastOneTrueGuard = AtLeastOneTrueGuard || s.testGuard();
           	if (s.testReady() && s.testGuard()) {
					int oldestSArrival = s.getOldestArrival();
					if (oldestSArrival < oldest) {
						i = j;
						oldest = oldestSArrival;
					}
				}
        }
        if (i == 0 && !AtLeastOneTrueGuard)
          return -1; // all guards are false
        else 
        	 return i;
    }

	public synchronized int choose() throws InterruptedException {

		int readyIndex = 0;
      readyIndex=testAll();
      if (readyIndex<=0) { // not ready
			if (hasElse)
				return list.size()+1;
        	openAll();
			if (hasDelay && delay.testGuard()) { // allow timeout
        		long startTime = System.currentTimeMillis();
   	     	long waitTime = delay.getMsecDelay();
        		wait(waitTime);
				readyIndex=testAll();
        		if (readyIndex <= 0) 
              	readyIndex = list.size()+1;
			} // allow timeout
			else { // no else or open delay
				if (readyIndex == -1)            // all accept alternatives have false guards
					throw new SelectException();  // && the delay alternative is closed or no else
				wait();
				readyIndex=testAll();
			} // no else or delay
		} // not ready
		clearAll();
		return readyIndex;
	} // choose

}


