import java.util.*;

public class selectablePort extends channel implements selectable {

	private Object message = null;
	private Object arrivalLock = new Object();
	private final Object sending = new Object();
	private final binarySemaphore sent = new binarySemaphore(0);
	private final binarySemaphore received = new binarySemaphore(0);
	private Thread receiver = null;
	private Object receiverLock = new Object();

	private boolean open = false;
	private int ready = 0;
	private IselectiveWait inchoice = null;
	private boolean guard_ = true;
	private static int timeStamp = 0;
	private Vector arrivals = new Vector();

	public selectablePort() { super(); }

	public final void send(Object sentMsg) {
		if (sentMsg == null) {
				throw new NullPointerException("Null message passed to send()");
		}
		else
		  setArrival();
		synchronized (sending) {
			message = sentMsg;
			signal();
			received.P();
		}
	}

	public final void send() {
		setArrival();
		synchronized (sending) {
			message = new Object();
			signal();
			received.P();
		}
	}

	synchronized void signal() {
		if (inchoice == null) {
			sent.V(); // if (open) notifyAll();
		} 
		else {
			synchronized (inchoice) {
				sent.V();	
				if (open) {   // is this is an entry that choice is waiting for?
					inchoice.notify(); 
				}
			}
		}
	}


	public final Object receive() {
		if (receiver == null)					// save the first Thread to call receive
			synchronized(receiverLock) {
				// guard against a context switch after if, allowing two threads to see (receiver == null)
				if (receiver == null)						
					receiver = Thread.currentThread();
			}

		if (Thread.currentThread() != receiver) {
			throw new InvalidPortUsage("Attempted to use port with multiple receivers");
		}

		Object receivedMessage = null;
		sent.P();
		receivedMessage = message;
		clearArrival();
		received.V();
		return receivedMessage;
	}

	private static synchronized int getTimeStamp() {
		return(++timeStamp);
	}

	public void setSelect(IselectiveWait s) {
		inchoice = s;
	}

	public int getOldestArrival() {
	// only called from choose() when ready>0, i.e., arrivals.size()>0
		synchronized(arrivalLock) {
			return (((Integer)arrivals.firstElement()).intValue());
		}
	}

	public int count() { return ready; }

    public boolean testReady() {
        return ready>0;
    }
    
    public void setArrival() {
    	synchronized(arrivalLock) {
    		++ready;
    		arrivals.addElement(new Integer(getTimeStamp()));
    	}
    }
    
    public void clearArrival() {
    	synchronized(arrivalLock) {
    		--ready;
    		arrivals.removeElementAt(0);
    	}
    }

    public void setOpen() {
        open=true;
    }

    public void clearOpen() {
         open=false;
    }

    public void guard(boolean g) {
        guard_=g;
    }

    public boolean testGuard(){
        return guard_;
    }
}

final class InvalidPortUsage extends InvalidChannelUsage {
	InvalidPortUsage() { }
	InvalidPortUsage(String msg) {super(msg);}
}
