public class port extends channel {

	private Object message = null;
	private final Object sending = new Object();
	private final binarySemaphore sent = new binarySemaphore(0);
	private final binarySemaphore received = new binarySemaphore(0);
	private Thread receiver = null;
	private Object receiverLock = new Object();

	public port() { super(); }

	public final void send(Object sentMsg) {
		if (sentMsg == null) {
				throw new NullPointerException("Null message passed to send()");
		}
		synchronized (sending) {
			message = sentMsg;
			sent.V();
			received.P();
		}
	}

	public final void send() {
		synchronized (sending) {
			message = new Object();
			sent.V();
			received.P();
		}
	}

	public final Object receive() {
		synchronized(receiverLock) {
			if (receiver == null)						
				receiver = Thread.currentThread();
		}

		if (Thread.currentThread() != receiver) {
			throw new InvalidPortUsage("Attempted to use port with multiple receivers");
		}

		Object receivedMessage = null;
		sent.P();
		receivedMessage = message;
		received.V();
		return receivedMessage;
	}
}

final class InvalidPortUsage extends InvalidChannelUsage {
	InvalidPortUsage() { }
	InvalidPortUsage(String msg) {super(msg);}
}
