import java.util.*;

public class selectablePort extends channel implements selectable {

	private Object message = null;
	private Object arrivalLock = new Object();
	private final Object sending = new Object();
	private final binarySemaphore sent = new binarySemaphore(0);
	private final binarySemaphore received = new binarySemaphore(0);
	private Thread receiver = null;
	private Object receiverLock = new Object();

	private boolean open = false;
	private int ready = 0;
	private IselectiveWait inchoice = null;
	private boolean guard_ = true;
	private static int timeStamp = 0;
	private Vector arrivals = new Vector();

	public selectablePort() { super(); }

	public final void send(Object sentMsg) {
		if (sentMsg == null) {
				throw new NullPointerException("Null message passed to send()");
		}
		else
		  setArrival();
		synchronized (sending) {
			message = sentMsg;
			signal();
			received.P();
		}
	}

	public final void send() {
		setArrival();
		synchronized (sending) {
			message = new Object();
			signal();
			received.P();
		}
	}

	synchronized void signal() {
		if (inchoice == null) {
			//System.out.println("inchoice is null");
/* RHC:
Don't need ++ready and can't keep it since we 
took --ready out of receive?

Q: But!!! what about an entry that will be inchoice and
will also not be inchoice? Consider:
- it's guard is false so it's not open, but it gets a call
- ++ready is executed below, 
- later, when used outside of select, --ready will not be 
  executed.
==> leave in --ready in receive and ++ ready below?
*/
			// already done in setArrival()
			//++ready; 
			//arrivals.addElement(new Integer(getTimeStamp()));
			sent.V(); // if (open) notifyAll();
		} 
		else {
			//System.out.println("inchoice is NOT null");
			synchronized (inchoice) {
				//System.out.println("incremented arrivals");
				// already done in setArrival()
				//++ready;
				//arrivals.addElement(new Integer(getTimeStamp()));
				sent.V();	
/* RHC:
This was notifyall() originally. Now there is only one thread
that could be waiting, i.e, the one waiting in choose()
*/	
				if (open) {   // is this is an entry that choice is waiting for?
					//System.out.println("notifying inchoice");
					inchoice.notify(); 
				}
			}
		}
	}


	public final Object receive() {
		if (receiver == null)					// save the first Thread to call receive
			synchronized(receiverLock) {
				// guard against a context switch after if, allowing two threads to see (receiver == null)
				if (receiver == null)						
					receiver = Thread.currentThread();
			}

		if (Thread.currentThread() != receiver) {
			throw new InvalidPortUsage("Attempted to use port with multiple receivers");
		}

		Object receivedMessage = null;
/* RHC: 
setOPen() and clearOpen() match the "// if (open) notifyAll();"
in signal() when inchoice==null. Since we use sent.V(), we don't
need these here. 
*/
		//setOpen();
		sent.P();
		//clearOpen();
/* RHC:
If do clearReady() in choose instead of here, we can make this
receive the same as one in class synchChannel. But problems
if entry used both in and out of select.
*/
		//clearReady();	// now done in clearArrival()
		receivedMessage = message;
		clearArrival();
		//arrivals.removeElementAt(0);
		received.V();
		return receivedMessage;
	}

	private static synchronized int getTimeStamp() {
		return(++timeStamp);
	}

	public void setSelect(IselectiveWait s) {
		inchoice = s;
	}

	public int getOldestArrival() {
	// only called from choose() when ready>0, i.e., arrivals.size()>0
		synchronized(arrivalLock) {
			return (((Integer)arrivals.firstElement()).intValue());
		}
	}

	public int count() { return ready; }

    public boolean testReady() {
        return ready>0;
    }
    
    public void setArrival() {
    	synchronized(arrivalLock) {
    		++ready;
    		arrivals.addElement(new Integer(getTimeStamp()));
    	}
    }
    
    public void clearArrival() {
    	synchronized(arrivalLock) {
    		--ready;
    		arrivals.removeElementAt(0);
    	}
    }

    //public synchronized void clearReady() {
    //    --ready;
    //}

    public void setOpen() {
        open=true;
    }

    public void clearOpen() {
         open=false;
    }

    public void guard(boolean g) {
        guard_=g;
    }

    public boolean testGuard(){
        return guard_;
    }
}

final class InvalidPortUsage extends InvalidChannelUsage {
	InvalidPortUsage() { }
	InvalidPortUsage(String msg) {super(msg);}
}
