import java.util.*;

public final class asynchLink extends channel {
	private final int capacity = 100;
	private Object messages[] = new Object[capacity];
	private countingSemaphore messageAvailable = new countingSemaphore(0);
   private int in = 0, out = 0;
	private Thread sender = null;
	private Thread receiver = null;
	private final Object senderLock = new Object();
	private final Object receiverLock = new Object();

	public final void send(Object sentMessage) {
		synchronized(senderLock) {
			if (sender == null)
				sender = Thread.currentThread();
		}

		if (Thread.currentThread() != sender)
			throw new InvalidLinkUsage("Attempted to use link with multiple senders");

   	if (sentMessage == null) {
   		throw new NullPointerException("null message passed to send()");
      }

		messages[in] = sentMessage;
      in = (in + 1) % capacity;
		messageAvailable.V();

	}

	public final void send() {
		synchronized(senderLock) {
				if (sender == null)
					sender = Thread.currentThread();
		}

		if (Thread.currentThread() != sender)
			throw new InvalidLinkUsage("Attempted to use link with multiple senders");


		messages[in] = new Object();
      in = (in + 1) % capacity;
		messageAvailable.V();

	}

	public final Object receive() {
		synchronized(receiverLock) {
			if (receiver == null)						
				receiver = Thread.currentThread();
		}

		if (Thread.currentThread() != receiver) {
			throw new InvalidLinkUsage("Attempted to use link with multiple receivers");
		}

		messageAvailable.P();
		Object receivedMessage = messages[out];  // Q needs to be synched? Is it by default?
      out = (out + 1) % capacity;
		return receivedMessage;
   }
}

final class InvalidLinkUsage extends InvalidChannelUsage {
	InvalidLinkUsage() { }
	InvalidLinkUsage(String msg) {super(msg);}
}
