import java.util.*;

public final class asynchMailbox extends channel {
	private final int capacity = 100;
	private Object messages[] = new Object[capacity];	// message buffer
	private countingSemaphore messageAvailable = new countingSemaphore(0);
	private countingSemaphore slotAvailable = new 
	countingSemaphore(capacity);
	private binarySemaphore senderMutex = new binarySemaphore(1);
	private binarySemaphore receiverMutex = new binarySemaphore(1);
	private int in = 0, out = 0;

	public final void send(Object sentMessage) {
		if (sentMessage == null) {
			throw new NullPointerException("null message passed to send()");
		}
		slotAvailable.P();
		senderMutex.P();
		messages[in] = sentMessage;
		in = (in + 1) % capacity;
		senderMutex.V();
		messageAvailable.V();
	}

	public final void send() {
		slotAvailable.P();
		senderMutex.P();
		messages[in] = new Object();;
		in = (in + 1) % capacity;
		senderMutex.V();
		messageAvailable.V();
	}
	
	public final Object receive() {
		messageAvailable.P();
		receiverMutex.P();
		Object receivedMessage = messages[out]; 
		out = (out + 1) % capacity;
		receiverMutex.V();
		slotAvailable.V();
		return receivedMessage;
   }
}
//Listing 5.3 Asynchronous asynchMailbox class.

