import java.util.*;

public final class asynchPort extends channel {
	private final int capacity = 100;
	private Object messages[] = new Object[capacity];
	private countingSemaphore messageAvailable = new countingSemaphore(0);
	private countingSemaphore slotAvailable = new countingSemaphore(capacity);
	private binarySemaphore mutex = new binarySemaphore(1);
   private int in = 0, out = 0;
	private Thread receiver = null;
	private final Object receiverLock = new Object();

	public final void send(Object sentMessage) {

   	if (sentMessage == null) {
   		throw new NullPointerException("null message passed to send()");
      }

		slotAvailable.P();
		mutex.P();
		messages[in] = sentMessage;
      in = (in + 1) % capacity;
		mutex.V();
		messageAvailable.V();

	}

	public final void send( ) {
		slotAvailable.P();
		mutex.P();
		messages[in] = new Object();
      in = (in + 1) % capacity;
		mutex.V();
		messageAvailable.V();

	}

	public final Object receive() {
		synchronized(receiverLock) {
			if (receiver == null)						
				receiver = Thread.currentThread();
		}

		if (Thread.currentThread() != receiver) {
			throw new InvalidPortUsage("Attempted to use port with multiple receivers");
		}

		messageAvailable.P();
		Object receivedMessage = messages[out]; 
      out = (out + 1) % capacity;
		slotAvailable.V();
		return receivedMessage;
   }
}

final class InvalidPortUsage extends InvalidChannelUsage {
	InvalidPortUsage() { }
	InvalidPortUsage(String msg) {super(msg);}
}
