/* This is an example program for using mailbox and message_ptr */

#include "messageptr.h"
#include "mailbox.h"
#include "thread.h"

class requestMessage {
public: 
	int contents;
	int ID;
	int getContents() {return contents;}
	requestMessage(int msg_, int ID_) : contents(msg_), ID(ID_)  {}
	requestMessage(const requestMessage& m) : contents(m.contents), ID(m.ID) {}
	requestMessage* clone() const {return new requestMessage(*this);}
};

class replyMessage {
public:
	int num;
	replyMessage(int num_) : num(num_) {}
	replyMessage(const replyMessage& m) : num(m.num) {}
	replyMessage* clone() const {return new replyMessage(*this);}
};

class Client : public Thread {
private:
	mailbox<requestMessage>& request;
	int ID;
	mailbox<replyMessage>& reply;
	int number;

public:
	Client (mailbox<requestMessage>& request_, mailbox<replyMessage>& reply_, int ID_, int number_) 
 		: request(request_), reply(reply_), ID(ID_), number(number_) {}
	void* run () {
		message_ptr<requestMessage> msg(new requestMessage(number,ID));
		request.send(msg);
		message_ptr<replyMessage> replyMsg =  reply.receive();
		//replyMessage* m = static_cast<replyMessage*> (replyMsg.get());
		//int i = (static_cast<replyMessage*> ((reply.receive()).get()))->num;
		int i = replyMsg->num;
		std::cout << number << " x " << number << " = " << i <<std::endl;
		return 0;
	}
};

class Server : public Thread {
private:
	mailbox<requestMessage>& request;
	mailbox<replyMessage>& reply;
public:
	Server (mailbox<requestMessage>& request_, mailbox<replyMessage>& reply_) : request(request_), reply(reply_) {}
	void* run () {
		int number;
		message_ptr<requestMessage> msg = request.receive();
		//requestMessage* m = static_cast<requestMessage*>(msg.get());
        number = msg->contents;
		message_ptr<replyMessage> result1(new replyMessage(number*number));
		//reply.send(message_ptr(new replyMessage(number*number)));
		reply.send(result1);
		msg = request.receive();
		//m = static_cast<requestMessage*>(msg.get());
		number = msg->contents;
		message_ptr<replyMessage> result2(new replyMessage(number*number));
		//reply.send(message_ptr(new replyMessage(number*number)));
		reply.send(result2);
		return 0;
	}
};

int main () {
	mailbox<requestMessage> request;	
	mailbox<replyMessage> reply;
	const int client1ID = 0;
	const int client2ID = 1;
	Client* c1 = new Client(request, reply, client1ID, 2);
	Client* c2 = new Client(request, reply, client2ID, 4);
	Server* s = new Server(request,reply);	
	c1->start(); c2->start();
	s->start();
	c1->join(); c2->join(); s->join();
	return 0;
}
