#ifndef MAILBOX_H
#define MAILBOX_H

#include "channel.h"
#include "win32semaphore.h"
#include "mutexLock.h"
#include "messageptr.h"

template <class T>
class mailbox { // : public channel {
public:
	mailbox() : sent(0), received(0), msg(0) {}
		void send(message_ptr<T>& sentMsg) {
		    if (sentMsg.get() == NULL) {
				std::cout << "Null message passed to send()" << std::endl;
				//throw new NullMessageException("Null message passed to send()");
			}
			mutexSending.lock();
			msg = sentMsg;
			sent.V(); 
			received.P(); 
			mutexSending.unlock();
	}
	message_ptr<T> receive() {
		mutexReceiving.lock();
		sent.P();
		message_ptr<T> receivedMessage = msg; 
		received.V();
		mutexReceiving.unlock();
		return receivedMessage;
	}
	void send() {
		mutexSending.lock();
		sent.V();
		received.P();
		mutexSending.unlock();
	}
private:
	message_ptr<T> msg;
	mutexLock mutexSending;
	mutexLock mutexReceiving;
	win32Semaphore sent;
	win32Semaphore received;
};

#endif
