#ifndef MESSAGEPTR_H
#define MESSAGEPTR_H

#include <iostream>

template <class X> class message_ptr {
public:
    explicit message_ptr(X* p = 0) // allocate a new counter
        : theCount(0) {if (p) theCount = new count(p);}
    ~message_ptr()
        {release();}
    message_ptr(const message_ptr& r) throw()
        {acquire(r.theCount);}
    message_ptr& operator=(const message_ptr& r)
    {
        if (this != &r) {
            release();
            acquire(r.theCount);
        }
        return *this;
    }
    X& operator*()  const throw()   {return *theCount->ptr;}
    X* operator->() const throw()   {return theCount->ptr;}
    X* get()        const throw()   {return theCount ? theCount->ptr : 0;}
    bool unique()   const throw()
        {return (theCount ? theCount->count == 1 : true);}

private:

    struct count {
        count(X* p = 0, unsigned c = 1) : ptr(p), refCount(c) {}
        X*          ptr;
        unsigned    refCount;
    }* theCount;

    void acquire(count* c) throw()
    { // increment the count
        theCount = c;
        if (c) ++c->refCount;
    }

    void release()
    { // decrement the count, delete if it is 0
        if (theCount) {
            if (--theCount->refCount == 0) {
                delete theCount->ptr;
                delete theCount;
            }
            theCount = 0;
        }
    }
};

#endif
