// this mutexLock suppoted race analysis but not tracing/replay
#include "mutexlock.h"
#include <windows.h>


mutexLock::mutexLock()
: owner(0), count(0), mutex(1) {}


void mutexLock::lock() {
	mutex.P();
	if (count == 0) {
		count = 1;
		owner = GetCurrentThreadId();
	}
	else if (owner == GetCurrentThreadId()) {
		++count;
	}
	else  {
		win32Semaphore* conditionVar = pool.acquire();
		waitingLock.push(conditionVar); // otherwise append blocked thread
		mutex.V();
		conditionVar->P();		// returns holding mutex since unlock() didn't release it
		count = 1;			
		owner = GetCurrentThreadId();
		pool.release(conditionVar);
	}
	mutex.V();
}

int mutexLock::unlock() {
	int returnCode=0;
	mutex.P();
	if (owner != 0) {
		if (owner == GetCurrentThreadId()) {
				--count;
				if (count == 0) {
					owner = 0;
					if (!waitingLock.empty()) { // any threads waiting for lock?
						win32Semaphore* oldest = waitingLock.front();
						waitingLock.pop();
						oldest->V();
						// do not release mutex so oldest will complete
						return returnCode;
					}
				}
				else {
					mutex.V();
					return returnCode;
				}
		}
		else {
			returnCode = -1;
		}
	}
	else {
		returnCode = -1;
	}
	mutex.V();
	return returnCode;
}



