public class link extends channel {

	private Object message = null;
	private final binarySemaphore sent = new binarySemaphore(0);
	private final binarySemaphore received = new binarySemaphore(0);
	private Thread sender = null;
	private Thread receiver = null;
	private Object senderLock = new Object();
	private Object receiverLock = new Object();

	public link() { super();	}

	public final void send(Object sentMsg) {
		synchronized(senderLock) {
			if (sender == null)
				sender = Thread.currentThread();
		}

		if (Thread.currentThread() != sender)
			throw new InvalidLinkUsage("Attempted to use link with multiple senders");

   	if (sentMsg == null)
      	throw new NullPointerException("Null message passed to send()");

		message = sentMsg;
		sent.V();
		received.P();
	}

	public final void send() {
		synchronized(senderLock) {
			if (sender == null)
				sender = Thread.currentThread();
		}

		if (Thread.currentThread() != sender)
			throw new InvalidLinkUsage("Attempted to use link with multiple senders");
		message = new Object();
		sent.V();
		received.P();
	}

	public final Object receive() {
		synchronized(receiverLock) {
			if (receiver == null)						
				receiver = Thread.currentThread();
		}

		if (Thread.currentThread() != receiver) {
			throw new InvalidLinkUsage("Attempted to use link with multiple receivers");
		}

		Object receivedMessage = null;
		sent.P();
		receivedMessage = message;
		received.V();
		return receivedMessage;
	}

}

final class InvalidLinkUsage extends InvalidChannelUsage {
	InvalidLinkUsage() { }
	InvalidLinkUsage(String msg) {super(msg);}
}
