public class monitorSC {
// Monitor Toolbox that uses VP() operation and SC signalling

	private binarySemaphore mutex = new binarySemaphore(1);

	protected final class conditionVariable {
		private countingSemaphore threadQueue = new countingSemaphore(0);
		private int numWaitingThreads = 0;

		public void signalC() {
			if (numWaitingThreads > 0) {
				numWaitingThreads--;
				threadQueue.V();
   		}
		}

		public void signalCall() {
			while (numWaitingThreads > 0) {
        		--numWaitingThreads;
	    		threadQueue.V();
   		}
		}	   	   

		public void waitC() {
   		numWaitingThreads++;
			threadQueue.VP(mutex);
			mutex.P();
		}

		public boolean empty() {
 			return (numWaitingThreads == 0);
		}

		public int length() {
			return numWaitingThreads;
		}
	}


	protected void enterMonitor() {
		mutex.P();
	}

	protected void exitMonitor() {	
		mutex.V();
	}


}

