import java.net.*;
import java.io.*;

public final class abp2 {
	public static void main(String args[]) {
	link nextMessage = new link();
	source client1 = new source(nextMessage);
	ABPSender sender = new ABPSender(nextMessage);
	link deliver = new link();
	destination client2 = new destination(deliver);
	ABPReceiver receiver = new ABPReceiver(deliver);	
	client1.start(); client2.start(); sender.start(); receiver.start();
	}
}
final class source extends Thread {
	private link nextMessage;
	public source(link nextMessage) {this.nextMessage = nextMessage;}
	public void run() {nextMessage.send("one");	nextMessage.send("two");	nextMessage.send("three");	}
}
	
final class destination extends Thread {
	private link deliver;
	public destination(link deliver) {this.deliver = deliver;}
	public void run() {
	String msg;
	msg = (String) deliver.receive(); 	System.out.println(msg);
	msg = (String) deliver.receive();		System.out.println(msg);
	msg = (String) deliver.receive();		System.out.println(msg);
	}
}
final class ABPSender extends Thread {
	private link nextMessage;
	TCPSender messageSender;
	TCPUnreliableSelectableMailbox ackMailbox;	// loses 50% of the acknowledgements that arrive
	final int receiverPort = 2022;
	final int senderPort = 2020;
	String receiverHost = null;
	private int sequenceNumber = 1;
	public ABPSender(link nextMessage) {this.nextMessage = nextMessage;}
	public void run() {
		try {
			receiverHost = InetAddress.getLocalHost().getHostName();
			ackMailbox = new TCPUnreliableSelectableMailbox (senderPort);
			messageSender = new TCPSender(receiverHost,receiverPort);
			selectiveWait select = new selectiveWait();
			selectiveWait.delayAlternative delayA = select.new delayAlternative(3000);
			select.add(ackMailbox);	// alternative 1
			select.add(delayA);	// alternative 2
			ackMailbox.guard(true);
			delayA.guard(true);
			while (true) {
				String nextMsg = (String) nextMessage.receive();				// accept message from client 1
				abpPacket packet = new abpPacket(nextMsg,sequenceNumber);
				messageParts msg = new messageParts(packet);
				boolean receivedAck = false;
				while (!receivedAck) {
					messageSender.send(msg);	// (re)send message to receiver
					switch (select.choose()) {
						case 1:	messageParts m = ackMailbox.receive();	// receive ack from receiver
									int ackNumber = ((Integer)m.obj).intValue();
									if (ackNumber == sequenceNumber) {receivedAck = true;}
									break;
						case 2: 	delayA.accept();	// timeout
									break;
					}
				}
				sequenceNumber = (sequenceNumber+1)%2;	// increment sequence number modulo 2
			}
	} 
	catch (InterruptedException e) {e.printStackTrace();}
	catch (UnknownHostException e) {e.printStackTrace();}
	catch (TCPChannelException e) {e.printStackTrace();}
	}
}

final class ABPReceiver extends Thread {
	private link deliver;
	TCPSender ackSender;
	TCPUnreliableMailbox messageMailbox;	// loses 50% of the messages that arrive
	final int receiverPort = 2022;
	final int senderPort = 2020;
	String senderHost = null;
	private int expectedSequenceNumber = 1;
	public ABPReceiver(link deliver) {this.deliver = deliver;}
	public void run() {
		try {
			senderHost = InetAddress.getLocalHost().getHostName();
			messageMailbox = new TCPUnreliableMailbox (receiverPort);
			ackSender = new TCPSender(senderHost,senderPort);
			while (true) {
				messageParts msg = (messageParts) messageMailbox.receive();	// receive message from sender
				abpPacket packet = (abpPacket) msg.obj; 
				if (packet.sequenceNumber == expectedSequenceNumber) {
					deliver.send(packet.obj);	// deliver message to client 2
					msg = new messageParts(new Integer(packet.sequenceNumber));
					ackSender.send(msg);	// send ack to sender
					expectedSequenceNumber = (expectedSequenceNumber+1)%2;
				}
				else {
					msg = new messageParts(new Integer(packet.sequenceNumber));
					ackSender.send(msg);		// resend ack to sender
				}
			}
		}
		catch (UnknownHostException e) {e.printStackTrace();}
		catch (TCPChannelException e) {e.printStackTrace();}
	}
}

class abpPacket implements Serializable{
	public abpPacket(Object obj,int sequenceNumber) {
	this.obj = obj;	this.sequenceNumber = sequenceNumber;
	}
	public Object obj;	// message 
	public int sequenceNumber;	// sequence number: 0 or 1
}

