import java.io.*;
import java.net.*;

public final class Client {

	public static void main (String args[]) {
		int serverPort = 2020; ObjectOutputStream toServer=null;
		ObjectInputStream fromServer = null; Socket socket = null;
		try {
			if (args.length != 1) {
				System.out.println("need 1 argument");
				System.exit(1);
			}
			int number = Integer.parseInt(args[0]);
			InetAddress serverHost = InetAddress.getLocalHost();
			socket = new Socket(serverHost,serverPort);
			socket.setSoTimeout(1000);
			toServer = new ObjectOutputStream(new BufferedOutputStream(socket.getOutputStream()));
   		Message msgToSend = new Message(number);
			toServer.writeObject(msgToSend);
			toServer.flush();
 			//This will block until the corresponding ObjectOutputStream has written and flushed the header.
      	fromServer = new ObjectInputStream(new BufferedInputStream(socket.getInputStream()));
      	Message msgFromReply = (Message) fromServer.readObject();
			System.out.println (number + " x " + number + " = " + msgFromReply.number);
		}
		catch (IOException e) { e.printStackTrace(); System.exit(1);}
		catch (ClassNotFoundException e) { e.printStackTrace(); System.exit(1);}
		finally {
			if (socket != null)
				try { socket.close();}
				catch (IOException e) { e.printStackTrace(); }
		}
	}
}



