import java.util.*;
import java.net.*;
import java.io.*;

public class TCPSynchronousSender {
	String destinationHostname = null;		//  destination host associated with this channel
	int destinationPort;							//  destination port associated with this channel
	Socket socket = null;
	ObjectOutputStream to = null;
	ObjectInputStream from = null;
	Object lock = new Object();

   public TCPSynchronousSender(String destinationHostname, int destinationPort ) {
		this.destinationHostname = destinationHostname;
		this.destinationPort = destinationPort;
	}
	
   public TCPSynchronousSender() { }
	
	public void connect() throws TCPChannelException {
		try {
			socket = new Socket( destinationHostname, destinationPort );
			to = new ObjectOutputStream(socket.getOutputStream());
			from = new ObjectInputStream(socket.getInputStream());
		} catch (Exception e) { e.printStackTrace(); throw new TCPChannelException(e.getMessage());}
	
	}
	
	public void close() throws TCPChannelException {
		try {
			if (to != null) to.close(); 
			if (from != null) from.close();
			if (socket != null) socket.close();
		} catch (Exception e) { e.printStackTrace(); throw new TCPChannelException(e.getMessage());}
	}

	public void send( messageParts message) throws TCPChannelException {
		try { synchronized(lock) {
					to.writeObject(message); to.flush();
					nullObject msg = (nullObject) from.readObject();
				}
		} 
		catch (NullPointerException e) {
			e.printStackTrace();
			throw new TCPChannelException("null stream - call connect() before sending messages");
		}
		catch (Exception e) { e.printStackTrace(); throw new TCPChannelException(e.getMessage());}
    }
   
	public void send( ) throws TCPChannelException{
		send(new messageParts(new nullObject()));
   }
}
