import java.io.*;
import java.net.*;

public final class Buffer {
	public static void main (String args[]) {
		final int depositPort = 2020;
		final int withdrawPort = 2021;
		final int withdrawReplyPort = 2022;  // if consumer's port is known
		int fullSlots=0;
		int capacity = 2;
		Object[] buffer = new Object[capacity];
		int in = 0, out = 0;
		final int numItems = 3;
		try {
			TCPSelectableSynchronousMailbox deposit = new TCPSelectableSynchronousMailbox(depositPort);
			TCPSelectableSynchronousMailbox withdraw = new TCPSelectableSynchronousMailbox(withdrawPort);
			//selectiveWait.delayAlternative delayA = select.new delayAlternative(500); // can be added
			String consumerHost = InetAddress.getLocalHost().getHostName(); // if consumer's host is known
			TCPSender withdrawReply = new TCPSender(consumerHost,withdrawReplyPort);
			
			withdrawReply.connect();
			selectiveWait select = new selectiveWait();
			select.add(deposit);				// alternative 1
			select.add(withdraw);			// alternative 2
			// select.add(delayA);			// alternative 3 can be added
			for (int i=0; i<(2*numItems); i++) {
				withdraw.guard(fullSlots>0);
				deposit.guard (fullSlots<capacity);
				//delayA.guard(true);
				switch (select.choose()) {
					case 1:	Object o = deposit.receive();
								buffer[in] = o;
								in = (in + 1) % capacity;
								++fullSlots;
								System.out.println("deposit");
								break;
					case 2:	messageParts withdrawRequest = withdraw.receive();
								messageParts m = (messageParts) buffer[out];
								withdrawReply.send(m); //(m,withdrawRequest.host,withdrawRequest.port);
								out = (out + 1) % capacity;
								--fullSlots;
								System.out.println("withdraw");
								break;
					//case 3: 	delayA.accept();
					//			//System.out.println("delay selected");
					//			break;
				}
			}
			withdrawReply.close();
		}
		catch (InterruptedException e) {e.printStackTrace();System.exit(1);}
		catch (UnknownHostException e) {e.printStackTrace();System.exit(1);}
    	catch (TCPChannelException e) {e.printStackTrace();System.exit(1);}
	}
}



