import java.io.*;
import java.net.*;

public final class Consumer {
	public static void main (String args[]) {
		final int withdrawPort = 2021;
		final int withdrawReplyPort = 2022;
		String consumerHost = null, bufferHost = null;
		try {
			consumerHost = bufferHost = InetAddress.getLocalHost().getHostName();
			TCPSynchronousSender withdraw = new TCPSynchronousSender(bufferHost,withdrawPort);
			TCPMailbox withdrawReply = new TCPMailbox(withdrawReplyPort);
			
			try {Thread.sleep(2000);} catch(InterruptedException e) {} // make sure Buffer is ready to connect	
			withdraw.connect();
			
			for (int i=0; i<3; i++) {
				messageParts msg = new messageParts(new nullObject(),consumerHost,withdrawReplyPort);
				withdraw.send(msg);
				messageParts m = (messageParts) withdrawReply.receive();
				Message item = (Message) m.obj;
				System.out.println("Consumed " + item.number);
			}
			withdraw.close();
		}
		catch (UnknownHostException e) {e.printStackTrace();}
    	catch (TCPChannelException e) {e.printStackTrace();}
		System.exit(0); // withdraw is blocked waiting for messages, so exit
	}
}



