import java.util.*;
import java.net.*;
import java.io.*;

public class TCPSender {
	String destinationHostname = null;		//  destination host associated with this channel
	int destinationPort;							//  destination port associated with this channel
	Socket socket = null;
	ObjectOutputStream to = null;
	Object lock = new Object();

   public TCPSender(String destinationHostname, int destinationPort ) {
		this.destinationHostname = destinationHostname;
		this.destinationPort = destinationPort;
	}
   
   public void connect() throws TCPChannelException {
		try {
			socket = new Socket( destinationHostname, destinationPort );
			to = new ObjectOutputStream(socket.getOutputStream());
		} catch (Exception e) { e.printStackTrace(); throw new TCPChannelException(e.getMessage());}
	
	}

	public void send( messageParts message) throws TCPChannelException{
		try {
			synchronized (lock) {
				to.writeObject(message); to.flush();
			}
		} 
		catch (NullPointerException e) {
			e.printStackTrace();
			throw new TCPChannelException("null stream - call connect() before sending messages");
		}
		catch (Exception e) { e.printStackTrace(); throw new TCPChannelException(e.getMessage());}
   }
   
	public void send( ) throws TCPChannelException{
		send(new messageParts(new nullObject()));
   }
   
   public void shutdownOutput() throws TCPChannelException {
		try {
			if (socket != null) socket.shutdownOutput();
		} catch (Exception e) { e.printStackTrace(); throw new TCPChannelException(e.getMessage());}
	}
  	public void close() throws TCPChannelException {
		try {
			if (to != null) to.close();  
			if (socket != null) socket.close();
		} catch (Exception e) { e.printStackTrace(); throw new TCPChannelException(e.getMessage());}
	}
}
